"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultBaseTranslations = exports.default = exports.BaseInput = void 0;
var React = _interopRequireWildcard(require("react"));
var ReactDOM = _interopRequireWildcard(require("react-dom"));
var Validators = _interopRequireWildcard(require("../../../validators"));
var _Guid = _interopRequireDefault(require("../../utils/Guid"));
var _ShallowEqual = require("../../utils/ShallowEqual");
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // Libs
// Misc
const defaultBaseTranslations = {
  required: 'Required'
};
exports.defaultBaseTranslations = defaultBaseTranslations;
class BaseInput extends React.Component {
  constructor(props) {
    let subscribe = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    super(props);
    this.componentId = (0, _Guid.default)();
    this.inputRef = void 0;
    this.containerRef = void 0;
    this.lastValidation = void 0;
    this.lastInfoText = void 0;
    const res = this.handleValueChange(this.props.value, true, [], props, true);
    this.state = {
      isValid: res.isValid,
      errors: res.errors,
      value: props.value ? props.value : '',
      touched: props.defaultTouched,
      disabled: false,
      focused: false,
      handleValueChangeEnabled: true
    };
    this.containerRef = /*#__PURE__*/React.createRef();
    this.inputRef = /*#__PURE__*/React.createRef();
    this.handleChange = this.handleChange.bind(this);
    this.handleBlur = this.handleBlur.bind(this);
    this.handleFocus = this.handleFocus.bind(this);
    this.setValid = this.setValid.bind(this);
    this.focus = this.focus.bind(this);
    this.scrollTo = this.scrollTo.bind(this);
    this.setInvalid = this.setInvalid.bind(this);
    this.disableComponent = this.disableComponent.bind(this);
    this.enableComponent = this.enableComponent.bind(this);
    this.touch = this.touch.bind(this);
    this.unTouch = this.unTouch.bind(this);
    if (subscribe) {
      this.subscribeSelf(props);
    }
  }
  componentWillUnmount() {
    if (!this.props.ignoreContext) {
      this.props.formContext && this.props.formContext.unSubscribe(this.componentId);
    }
  }
  componentDidUpdate(oldProps, oldState) {
    if (oldProps.value !== this.props.value || oldProps.validators !== this.props.validators || oldProps.customValidators !== this.props.customValidators || oldProps.required !== this.props.required) {
      this.handleValueChange(this.props.value, true, [], this.props);
    }
  }
  scrollTo() {
    const domNode = ReactDOM.findDOMNode(this.containerRef.current);
    domNode && domNode.scrollIntoView({
      behavior: 'smooth'
    });
  }
  touch() {
    this.setState({
      touched: true
    });
    this.handleValueChange(this.state.value || '');
  }
  unTouch() {
    this.setState({
      touched: false
    });
  }
  disableComponent() {
    this.setState({
      disabled: true
    });
  }
  enableComponent() {
    this.setState({
      disabled: false
    });
  }
  focus() {
    var _this$props$onFocus, _this$props;
    if (this.inputRef) {
      const domNode = ReactDOM.findDOMNode(this.inputRef.current);
      domNode && domNode.focus();
    }
    (_this$props$onFocus = (_this$props = this.props).onFocus) === null || _this$props$onFocus === void 0 ? void 0 : _this$props$onFocus.call(_this$props);
    this.touch();
  }
  shouldComponentUpdate(nextProps, nextState) {
    let shouldUpdate = !(0, _ShallowEqual.shallowEqual)(this.props, nextProps, !this.props.reRendersWhenContextChanges ? 'formContext' : undefined) || !(0, _ShallowEqual.shallowEqual)(this.state, nextState);
    return shouldUpdate;
  }
  getValidationClass(extraErrors) {
    if (!this.props.showValidation || !this.state.touched) {
      return 'validation__success';
    }
    return this.state.isValid && (!this.props.errors || this.props.errors.length === 0) && (!this.state.errors || this.state.errors.length === 0) && (!extraErrors || extraErrors.length === 0) ? 'validation__success' : 'validation__error';
  }
  renderDefaultValidation(extraErrors) {
    if (this.props.disabled) {
      return null;
    }
    if (!this.props.showValidation) {
      return null;
    }
    let finalErrors = (this.state.errors ?? []).concat(extraErrors ?? []).concat(this.props.errors ?? []).filter(i => i);
    if (finalErrors.length > 0) {
      this.lastValidation = finalErrors.map((item, index) => /*#__PURE__*/React.createElement("li", {
        key: index,
        className: "validation__item"
      }, item));
    }
    if (this.props.infoText && this.state.isValid) {
      this.lastInfoText = [/*#__PURE__*/React.createElement("li", {
        key: 1,
        className: "info-text__item"
      }, this.props.infoText)];
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: "validation__container"
    }, /*#__PURE__*/React.createElement("ul", {
      className: "validation__ul"
    }, this.lastValidation)), /*#__PURE__*/React.createElement("div", {
      className: "info-text__container"
    }, /*#__PURE__*/React.createElement("ul", {
      className: "info-text__ul"
    }, this.lastInfoText)));
  }
  handleChange(event, isValid) {
    let errors = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    let value = event.target.value;
    if (!this.props.onTheFlightValidate || this.props.onTheFlightValidate && this.props.onTheFlightValidate(value)) {
      const res = this.handleValueChange(value, isValid, errors);
      if (this.props.onChange) {
        this.props.onChange(event, res.isValid);
      }
    }
  }
  subscribeSelf(props) {
    if (!props.ignoreContext && props.formContext) {
      props.formContext.subscribe(this.componentId, {
        componentApi: {
          disableComponent: this.disableComponent,
          enableComponent: this.enableComponent,
          touch: this.touch,
          unTouch: this.unTouch,
          scrollTo: this.scrollTo,
          focus: this.focus
        },
        validation: {
          isValid: this.state.isValid,
          errors: this.state.errors,
          name: this.props.validationName ? this.props.validationName : this.props.title ? this.props.title : this.props.label
        }
      });
    }
  }
  handleBlur() {
    var _this$props$onBlur, _this$props2;
    (_this$props$onBlur = (_this$props2 = this.props).onBlur) === null || _this$props$onBlur === void 0 ? void 0 : _this$props$onBlur.call(_this$props2);
    let state = {
      focused: false
    };
    if (!this.state.touched && this.props.touchOn === 'blur') {
      state = Object.assign(state, {
        touched: true
      });
      this.handleValueChange(this.state.value);
    }
    this.setState(state);
  }
  handleFocus() {
    if (!this.props.disabled) {
      var _this$props$onFocus2, _this$props3;
      (_this$props$onFocus2 = (_this$props3 = this.props).onFocus) === null || _this$props$onFocus2 === void 0 ? void 0 : _this$props$onFocus2.call(_this$props3);
      let state = {
        focused: true
      };
      if (!this.state.touched && this.props.touchOn === 'focus') {
        state = Object.assign(state, {
          touched: true
        });
        this.handleValueChange(this.state.value);
      }
      this.setState(state);
    }
  }
  getDisabled() {
    return this.state.disabled ? this.state.disabled : this.props.disabled;
  }
  setValid() {
    this.setState(() => ({
      isValid: true,
      errors: []
    }), () => {
      if (!this.props.ignoreContext) {
        this.props.formContext && this.props.formContext.updateCallback(this.componentId, {
          validation: {
            isValid: true,
            errors: []
          }
        });
      }
    });
  }
  setInvalid() {
    let errors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    this.setState(() => ({
      isValid: false,
      errors
    }), () => {
      if (!this.props.ignoreContext) {
        this.props.formContext && this.props.formContext.updateCallback(this.componentId, {
          validation: {
            isValid: false,
            errors: errors
          }
        });
      }
    });
  }
  renderLabel() {
    let touchable = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    if (!this.props.tooltip || this.props.tooltip && this.props.title) {
      return /*#__PURE__*/React.createElement("span", {
        className: (0, _classnames.default)('w-100', {
          'label--no-touch': !touchable
        })
      }, this.props.label);
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
      className: touchable ? '' : 'label--no-touch'
    }, this.props.label), this.renderTooltip());
  }
  renderTitle() {
    if (!this.props.tooltip) {
      return this.props.title;
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, this.props.title, this.renderTooltip());
  }
  handleValueChange(value) {
    let isValid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    let errors = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    let props = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : this.props;
    let initializing = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
    if (!initializing && !this.state.handleValueChangeEnabled) {
      return {
        isValid,
        errors: []
      };
    }
    if (props.required && !value) {
      const translations = this.getTranslations(defaultBaseTranslations);
      errors.push(translations.required);
      isValid = false;
    } else {
      if (!props.required && !value) {
        isValid = true;
      } else {
        if (props.validators) {
          isValid = true;
          props.validators.forEach(validator => {
            let validInner = false;
            switch (validator) {
              case 'email':
                validInner = new Validators.EmailValidator().Validate(value, props.required, error => errors.push(error));
                break;
              case 'number':
                validInner = new Validators.NumberValidator().Validate(value, props.required, error => errors.push(error));
                break;
              case 'latitude':
                validInner = new Validators.LatitudeValidator().Validate(value, props.required, error => errors.push(error));
                break;
              case 'longitude':
                validInner = new Validators.LongitudeValidator().Validate(value, props.required, error => errors.push(error));
                break;
              case 'url':
                validInner = new Validators.UrlValidator().Validate(value, props.required, error => errors.push(error));
                break;
              default:
                throw new Error(`Validator ${validator} not implemented`);
            }
            if (isValid && !validInner) {
              isValid = validInner;
            }
          });
        }
        if (props.customValidators) {
          props.customValidators.forEach(customValidator => {
            let validInner = false;
            validInner = customValidator.Validate(value, props.required, error => errors.push(error));
            if (isValid && !validInner) {
              isValid = validInner;
            }
          });
        }
      }
    }
    props.onErrorsChanged && props.onErrorsChanged(errors);
    if (!initializing) {
      this.setState({
        value,
        isValid,
        errors
      });
      if (!props.ignoreContext) {
        props.formContext && props.formContext.updateCallback(this.componentId, {
          validation: {
            isValid: isValid,
            errors: errors
          }
        });
      }
    }
    return {
      isValid,
      errors
    };
  }
  renderTooltip() {
    let content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : /*#__PURE__*/React.createElement("span", {
      className: "label--help-icon"
    }, "?");
    if (this.props.tooltip) {
      var _document;
      const Tippy = require('@tippy.js/react').default;
      return /*#__PURE__*/React.createElement(Tippy, _extends({
        content: this.props.tooltip,
        placement: "bottom",
        animation: "scale-subtle",
        arrow: false,
        duration: 200,
        delay: [75, 0],
        distance: 8,
        interactive: true,
        appendTo: (_document = document) === null || _document === void 0 ? void 0 : _document.body,
        trigger: "mouseenter focus"
      }, this.props.tooltipProps), content);
    }
    return content;
  }
  getTranslations(_defaultTranslations) {
    return _objectSpread(_objectSpread({}, _defaultTranslations), this.props.translations);
  }
}
exports.BaseInput = BaseInput;
BaseInput.defaultProps = {
  className: undefined,
  required: false,
  label: undefined,
  disabled: false,
  touchOn: 'focus',
  ignoreContext: false,
  showValidation: true,
  formContext: undefined,
  reRendersWhenContextChanges: false
};
var _default = BaseInput;
exports.default = _default;
//# sourceMappingURL=BaseInput.js.map