import * as React from 'react';
import { BookingCalendarClasses } from './classes';
import { BookingCalendarDateRange, BookingCalendarItemT, GetNewMomentFunctionType, GetMomentFormatFunctionType, ZoomLevel } from './common';
import { BookingCalendarControlsProps } from './bookingCalendarControls/BookingCalendarControls';
import { LaneSourceData } from './utils';
import { BookingCalendarLaneProps } from './bookingCalendarLane/BookingCalendarLane';
import { Moment, Duration } from 'moment';
import { BookingCalendarItemProps } from './bookingCalendarItem';
import { BookingCalendarRenderItemProps } from './bookingCalendarRenderItem';
import { BookingCalendarGridProps } from './bookingCalendarGrid/BookingCalendarGrid';
import { BookingCalendarLaneHeaderProps } from './bookingCalendarLaneHeader';
import { BookingCalendarLanesHeaderProps } from './bookingCalendarLanesHeader';
import { BookingCalendarDatePickerProps } from './bookingCalendarDatePicker';
import { BookingCalendarNowSectionProps } from './bookingCalendarNowSection';
export interface BookingCalendarProps<T extends BookingCalendarItemT, TLaneData> extends BookingCalendarClasses {
    getMoment?: () => Moment;
    bookings: T[];
    from: Moment;
    till: Moment;
    getMomentFormatFunction?: GetMomentFormatFunctionType;
    getNewMomentFunction?: GetNewMomentFunctionType;
    onRangeChange?: (range: BookingCalendarDateRange) => void;
    step?: Duration;
    showZoomAllButton?: boolean;
    showGrid?: boolean;
    gridAvailableSteps?: Duration[];
    goalGridWidthPx?: number;
    minLanesCount?: number;
    lanesSource?: LaneSourceData<T, TLaneData>[];
    unmatchedLanesToFront?: boolean;
    children?: React.ReactNode;
    bookingCalendarTopLeftHeader?: React.ReactNode;
    filteringButton?: React.ReactNode;
    zoomLevels?: ZoomLevel[];
    filterBookingsToZoom?: (booking: T) => boolean;
    showSelection?: boolean;
    minSelectionSize?: number;
    onSelection?: (items: T[], from: Moment, till: Moment, e: React.MouseEvent<HTMLElement>) => void;
    selectionContent?: React.ReactNode;
    showHeader?: boolean;
    showTimeAxis?: boolean;
    showNowSection?: boolean;
    alwaysShowNowSections?: boolean;
    headersClickEnabled?: boolean;
    onHeaderClick?: (range: BookingCalendarDateRange) => void;
    BookingCalendarItem?: React.ComponentType<BookingCalendarItemProps<T>>;
    BookingCalendarRenderItem?: React.ComponentType<BookingCalendarRenderItemProps<T>>;
    BookingCalendarLane?: React.ComponentType<BookingCalendarLaneProps<T>>;
    BookingCalendarControls?: React.ComponentType<BookingCalendarControlsProps<T>>;
    BookingCalendarGrid?: React.ComponentType<BookingCalendarGridProps>;
    BookingCalendarLaneHeader?: React.ComponentType<BookingCalendarLaneHeaderProps<TLaneData>>;
    BookingCalendarLanesHeader?: React.ComponentType<BookingCalendarLanesHeaderProps<T>>;
    BookingCalendarDatePicker?: React.ComponentType<BookingCalendarDatePickerProps<T>> | React.ReactNode;
    BookingCalendarNowSection?: React.ComponentType<BookingCalendarNowSectionProps>;
}
export declare function BookingCalendar<T extends BookingCalendarItemT, TLaneData>(props: BookingCalendarProps<T, TLaneData>): React.JSX.Element;
