import * as React from 'react';
import { BookingCalendarDateRange, BookingCalendarItemT, ZoomLevel } from '../common';
import { Duration, Moment } from 'moment';
import { BookingCalendarControlsClasses } from './classes';
export interface BookingCalendarControlsProps<T extends BookingCalendarItemT> extends BookingCalendarControlsClasses {
    getMoment: () => Moment;
    items: T[];
    step: Duration;
    from: Moment;
    till: Moment;
    zoomLevels?: ZoomLevel[];
    onRangeChange?: (range: BookingCalendarDateRange) => void;
    filterBookingsToZoom?: (booking: T) => boolean;
    bookingCalendarDatePicker?: React.ReactNode;
    filteringButton?: React.ReactNode;
    showZoomAllButton?: boolean;
}
export declare function BookingCalendarControls<T extends BookingCalendarItemT>(props: BookingCalendarControlsProps<T>): React.JSX.Element;
