"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BookingCalendarControls = BookingCalendarControls;
var _classnames = _interopRequireDefault(require("classnames"));
var React = _interopRequireWildcard(require("react"));
var _moment = _interopRequireDefault(require("moment"));
var _classes = require("./classes");
var _Button = require("../../button/Button");
var _Menu = _interopRequireDefault(require("@mui/material/Menu"));
var _MenuItem = _interopRequireDefault(require("@mui/material/MenuItem"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var LeftArrowLongIcon = function LeftArrowLongIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M20 11H7.83l5.59-5.59L12 4l-8 8 8 8 1.41-1.41L7.83 13H20v-2z"
  }));
};
LeftArrowLongIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var LeftArrowIcon = function LeftArrowIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M15.41 16.09l-4.58-4.59 4.58-4.59L14 5.5l-6 6 6 6z"
  }));
};
LeftArrowIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var RightArrowLongIcon = function RightArrowLongIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M12 4l-1.41 1.41L16.17 11H4v2h12.17l-5.58 5.59L12 20l8-8z"
  }));
};
RightArrowLongIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var RightArrowIcon = function RightArrowIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M8.59 16.34l4.58-4.59-4.58-4.59L10 5.75l6 6-6 6z"
  }));
};
RightArrowIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var UnfoldLessIcon = function UnfoldLessIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M7.41 18.59L8.83 20 12 16.83 15.17 20l1.41-1.41L12 14l-4.59 4.59zm9.18-13.18L15.17 4 12 7.17 8.83 4 7.41 5.41 12 10l4.59-4.59z"
  }));
};
UnfoldLessIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var DateRangeIcon = function DateRangeIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M9 11H7v2h2v-2zm4 0h-2v2h2v-2zm4 0h-2v2h2v-2zm2-7h-1V2h-2v2H8V2H6v2H5c-1.11 0-1.99.9-1.99 2L3 20a2 2 0 0 0 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H5V9h14v11z"
  }));
};
DateRangeIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var TodayIcon = function TodayIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M19 3h-1V1h-2v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19a2 2 0 0 0 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V8h14v11zM7 10h5v5H7z"
  }));
};
TodayIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
function BookingCalendarControls(props) {
  const {
    getMoment,
    className,
    monthLabelClassName,
    buttonsContainerClassName,
    zoomBookingsButtonClassName,
    zoomLevelsButtonClassName,
    zoomLevelsButtonLabelClassName,
    zoomLevels,
    step,
    from,
    till,
    onRangeChange,
    items,
    filterBookingsToZoom = () => true,
    bookingCalendarDatePicker,
    filteringButton,
    showZoomAllButton
  } = props;
  if (!step || !from || !till) {
    return null;
  }
  const selectedLevel = React.useMemo(() => zoomLevels === null || zoomLevels === void 0 ? void 0 : zoomLevels.find(level => till.valueOf() - from.valueOf() === level.step.asMilliseconds()), [zoomLevels, till, from]);
  const onStepFactory = React.useCallback(_step => () => onRangeChange({
    from: from.clone().add(_step),
    till: till.clone().add(_step)
  }), [from, till, onRangeChange]);
  const onBigStepLeftClick = React.useCallback(onStepFactory(_moment.default.duration(-7, 'days')), [onStepFactory, till, from]);
  const onSmallStepLeftClick = React.useCallback(onStepFactory(_moment.default.duration(-1, 'day')), [onStepFactory, step]);
  const onBigStepRightClick = React.useCallback(onStepFactory(_moment.default.duration(7, 'days')), [onStepFactory, till, from]);
  const onSmallStepRightClick = React.useCallback(onStepFactory(_moment.default.duration(1, 'day')), [onStepFactory, step]);
  const onTodayClick = React.useCallback(() => onRangeChange({
    from: getMoment().startOf('day'),
    till: getMoment().startOf('day').add((selectedLevel === null || selectedLevel === void 0 ? void 0 : selectedLevel.step) ?? step)
  }), [onRangeChange, step, getMoment]);
  const isTodayVisible = React.useMemo(() => from.isBefore((0, _moment.default)()) && (0, _moment.default)(from).add(1, 'day').isAfter((0, _moment.default)()), [from, till]);
  const filteredItems = React.useMemo(() => items === null || items === void 0 ? void 0 : items.filter(filterBookingsToZoom), [filterBookingsToZoom, items]);
  const onZoomBookingsClick = React.useCallback(() => {
    const minFromMs = Math.min(...(filteredItems === null || filteredItems === void 0 ? void 0 : filteredItems.filter(filterBookingsToZoom).map(a => a.from.valueOf()))) ?? (from === null || from === void 0 ? void 0 : from.valueOf());
    const minFrom = from.clone().subtract(from.valueOf() - minFromMs, 'ms');
    const maxTillMs = Math.max(...(filteredItems === null || filteredItems === void 0 ? void 0 : filteredItems.filter(filterBookingsToZoom).map(a => a.till.valueOf()))) ?? (till === null || till === void 0 ? void 0 : till.valueOf());
    const maxTill = till.clone().subtract(till.valueOf() - maxTillMs, 'ms');
    onRangeChange({
      from: minFrom,
      till: maxTill
    });
  }, [from, till, filteredItems]);
  const [anchorEl, setAnchorEl] = React.useState(null);
  const open = Boolean(anchorEl);
  const handleClick = event => {
    setAnchorEl(event.currentTarget);
  };
  const handleClose = () => {
    setAnchorEl(null);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(_classes.bookingCalendarControlsDefaultClasses.className, className)
  }, bookingCalendarDatePicker && /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(_classes.bookingCalendarControlsDefaultClasses.monthLabelClassName, monthLabelClassName)
  }, bookingCalendarDatePicker), /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(_classes.bookingCalendarControlsDefaultClasses.buttonsContainerClassName, buttonsContainerClassName)
  }, (zoomLevels === null || zoomLevels === void 0 ? void 0 : zoomLevels.length) > 0 && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button.Button, {
    className: (0, _classnames.default)(_classes.bookingCalendarControlsDefaultClasses.zoomLevelsButtonClassName, zoomLevelsButtonClassName),
    "aria-haspopup": "true",
    "aria-expanded": open ? 'true' : undefined,
    onClick: handleClick,
    noShadow: true
  }, /*#__PURE__*/React.createElement(DateRangeIcon, null), selectedLevel ? /*#__PURE__*/React.createElement("span", {
    className: (0, _classnames.default)(_classes.bookingCalendarControlsDefaultClasses.zoomLevelsButtonLabelClassName, zoomLevelsButtonLabelClassName)
  }, ` ${selectedLevel.label}`) : ''), /*#__PURE__*/React.createElement(_Menu.default, {
    anchorEl: anchorEl,
    open: open,
    onClose: handleClose
  }, zoomLevels.map((level, index) => /*#__PURE__*/React.createElement(_MenuItem.default, {
    "data-level": index,
    key: index,
    onClick: () => {
      onRangeChange({
        from: from.clone().startOf('day'),
        till: from.clone().startOf('day').add(level.step)
      });
      setAnchorEl(null);
    },
    selected: till.valueOf() - from.valueOf() === level.step.asMilliseconds()
  }, level.label)))), /*#__PURE__*/React.createElement(_Button.Button, {
    noShadow: true,
    onClick: onBigStepLeftClick
  }, /*#__PURE__*/React.createElement(LeftArrowLongIcon, null)), /*#__PURE__*/React.createElement(_Button.Button, {
    noShadow: true,
    onClick: onSmallStepLeftClick
  }, /*#__PURE__*/React.createElement(LeftArrowIcon, null)), /*#__PURE__*/React.createElement(_Button.Button, {
    disabled: isTodayVisible,
    noShadow: true,
    onClick: onTodayClick
  }, /*#__PURE__*/React.createElement(TodayIcon, null)), /*#__PURE__*/React.createElement(_Button.Button, {
    noShadow: true,
    onClick: onSmallStepRightClick
  }, /*#__PURE__*/React.createElement(RightArrowIcon, null)), /*#__PURE__*/React.createElement(_Button.Button, {
    noShadow: true,
    onClick: onBigStepRightClick
  }, /*#__PURE__*/React.createElement(RightArrowLongIcon, null)), showZoomAllButton && /*#__PURE__*/React.createElement(_Button.Button, {
    className: (0, _classnames.default)(_classes.bookingCalendarControlsDefaultClasses.zoomBookingsButtonClassName, zoomBookingsButtonClassName),
    noShadow: true,
    disabled: !(filteredItems !== null && filteredItems !== void 0 && filteredItems.length),
    onClick: onZoomBookingsClick
  }, /*#__PURE__*/React.createElement(UnfoldLessIcon, null)), filteringButton));
}
//# sourceMappingURL=BookingCalendarControls.js.map