"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BookingCalendarLane = BookingCalendarLane;
var _classnames = _interopRequireDefault(require("classnames"));
var React = _interopRequireWildcard(require("react"));
var _BookingCalendarItem = require("../bookingCalendarItem/BookingCalendarItem");
var _utils = require("../utils");
var _classes = require("./classes");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function BookingCalendarLane(props) {
  const {
    className,
    items,
    laneIndex,
    from,
    till,
    step,
    BookingCalendarItem = _BookingCalendarItem.BookingCalendarItem,
    BookingCalendarRenderItem
  } = props;
  const calculatedItems = React.useMemo(() => items !== null && items !== void 0 && items.length ? (0, _utils.calculateItemsDimensions)(items, from, till) : [], [items, from, till]);
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(_classes.bookingCalendarLaneDefaultClasses.className, className)
  }, calculatedItems === null || calculatedItems === void 0 ? void 0 : calculatedItems.map((item, itemIndex) => item.width > 0 ? /*#__PURE__*/React.createElement(BookingCalendarItem, _extends({
    BookingCalendarRenderItem: BookingCalendarRenderItem,
    key: itemIndex,
    itemIndex: itemIndex,
    laneIndex: laneIndex,
    from: from,
    till: till,
    step: step
  }, item)) : null));
}
//# sourceMappingURL=BookingCalendarLane.js.map