"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BookingCalendarLanesHeader = BookingCalendarLanesHeader;
var _classnames = _interopRequireDefault(require("classnames"));
var React = _interopRequireWildcard(require("react"));
var _classes = require("./classes");
var _utils = require("../utils");
var _bookingCalendarLane = require("../bookingCalendarLane");
var _BookingCalendarLanesHeaderRenderItem = require("./BookingCalendarLanesHeaderRenderItem");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function BookingCalendarLanesHeader(props) {
  const {
    className,
    laneClassName,
    step,
    from,
    till,
    onRangeChange
  } = props;
  if (!step || !from || !till) {
    return null;
  }
  const items = React.useMemo(() => (0, _utils.generateControlItems)(from, till, step, from === null || from === void 0 ? void 0 : from.clone().startOf('day')), [from, till, step]);
  const BookingCalendarLanesHeaderRenderItem = React.useMemo(() => (0, _BookingCalendarLanesHeaderRenderItem.BookingCalendarLanesHeaderRenderItemFactory)(onRangeChange), [onRangeChange]);
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(_classes.bookingCalendarLanesHeaderDefaultClasses.className, className)
  }, /*#__PURE__*/React.createElement(_bookingCalendarLane.BookingCalendarLane, {
    className: (0, _classnames.default)(_classes.bookingCalendarLanesHeaderDefaultClasses.laneClassName, laneClassName),
    items: items,
    from: from,
    till: till,
    laneIndex: -1,
    BookingCalendarRenderItem: BookingCalendarLanesHeaderRenderItem,
    step: step
  }));
}
//# sourceMappingURL=BookingCalendarLanesHeader.js.map