"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BookingCalendarLanesHeaderRenderItemFactory = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _classes = require("../bookingCalendarRenderItem/classes");
var _Button = require("../../button/Button");
var _moment = _interopRequireDefault(require("moment"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const BookingCalendarLanesHeaderRenderItemFactory = onRangeChange => function BookingCalendarLanesHeaderRenderItem(props) {
  const {
    item,
    className,
    startIsCut,
    endIsCut,
    realFrom,
    realTill
  } = props;
  const onClick = React.useCallback(() => onRangeChange === null || onRangeChange === void 0 ? void 0 : onRangeChange({
    from: item.from,
    till: item.till
  }), [item, onRangeChange]);
  const isToday = item.from.isSame((0, _moment.default)(), 'day') && item.till.diff(item.from, 'hours') === 24;
  const ButtonComponent = onRangeChange ? _Button.Button : 'div';
  return item ? /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(_classes.bookingCalendarRenderItemDefaultClasses.className, className)
  }, /*#__PURE__*/React.createElement(ButtonComponent, _extends({
    className: (0, _classnames.default)('bookingCalendar__lanesHeader__renderItem__button', {
      'bookingCalendar__lanesHeader__renderItem__button--today': isToday
    })
  }, onRangeChange ? {
    noShadow: true,
    onClick: onClick,
    type: 'primary'
  } : {}), startIsCut || endIsCut ? /*#__PURE__*/React.createElement(React.Fragment, null, item.from.format('ddd, Do'), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("span", {
    className: "bookingCalendar__lanesHeader__renderItem__button__mutedText bookingCalendar__lanesHeader__renderItem__button__mutedText--split"
  }, /*#__PURE__*/React.createElement("span", null, startIsCut && realFrom.format('M/D H:mm')), /*#__PURE__*/React.createElement("span", null, endIsCut && realTill.format('M/D H:mm')))) : /*#__PURE__*/React.createElement(React.Fragment, null, item.from.format('ddd'), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("span", {
    className: "bookingCalendar__lanesHeader__renderItem__button__mutedText"
  }, item.from.format('Do'))))) : null;
};
exports.BookingCalendarLanesHeaderRenderItemFactory = BookingCalendarLanesHeaderRenderItemFactory;
//# sourceMappingURL=BookingCalendarLanesHeaderRenderItem.js.map