"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BookingCalendarNowSection = BookingCalendarNowSection;
var React = _interopRequireWildcard(require("react"));
var _classes = require("./classes");
var _classnames = _interopRequireDefault(require("classnames"));
var _moment = _interopRequireDefault(require("moment"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function BookingCalendarNowSection(props) {
  const {
    className,
    areaAfter,
    areaBefore,
    now,
    dataRowsCount,
    firstDataRowIndex,
    width,
    from,
    till,
    alwaysShowSections
  } = props;
  const style = React.useMemo(() => _objectSpread({
    gridRowStart: firstDataRowIndex,
    gridRowEnd: `span ${dataRowsCount}`
  }, width ? {
    width: `${width}px`
  } : {}), [dataRowsCount, width, firstDataRowIndex]);
  const widthMs = till.valueOf() - from.valueOf();
  const startMs = from.valueOf();
  const endMs = till.valueOf();
  const onePxMs = Math.max(widthMs / (width || 1), 5000);
  const [nowMs, setNowMs] = React.useState((0, _moment.default)().valueOf());
  const renderBefore = nowMs > startMs;
  const renderAfter = nowMs < endMs;
  React.useEffect(() => {
    if (renderBefore && renderAfter) {
      const interval = setInterval(() => {
        setNowMs((0, _moment.default)().valueOf());
      }, onePxMs);
      return () => clearInterval(interval);
    }
  }, [onePxMs, renderBefore, renderAfter]);
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(className, _classes.bookingCalendarNowSectionDefaultClasses.className),
    style: style
  }, renderBefore && (alwaysShowSections || renderAfter) && /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(areaBefore, _classes.bookingCalendarNowSectionDefaultClasses.areaBefore),
    style: {
      width: `${(nowMs - startMs) / widthMs * 100}%`
    }
  }), renderBefore && renderAfter && /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(now, _classes.bookingCalendarNowSectionDefaultClasses.now)
  }), renderAfter && (alwaysShowSections || renderBefore) && /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(areaAfter, _classes.bookingCalendarNowSectionDefaultClasses.areaAfter),
    style: {
      width: `${(endMs - nowMs) / widthMs * 100}%`
    }
  }));
}
//# sourceMappingURL=BookingCalendarNowSection.js.map