import * as React from 'react';
export type BookingCalendarSelectionCoordinates = [number, number];
export interface BookingCalendarSelectionData {
    origin: BookingCalendarSelectionCoordinates;
    target: BookingCalendarSelectionCoordinates;
}
export interface BookingCalendarSelectionProps {
    disabled?: boolean;
    onSelecting?: (data: {
        origin: BookingCalendarSelectionCoordinates;
        target: BookingCalendarSelectionCoordinates;
    }) => void;
    onSelected?: (data: {
        origin: BookingCalendarSelectionCoordinates;
        target: BookingCalendarSelectionCoordinates;
    }, e: React.MouseEvent<HTMLElement>) => void;
    dataRowsCount: number;
    firstDataRowIndex: number;
    minSelectionSize: number;
    children?: React.ReactNode;
    width: number;
}
export interface BookingCalendarSelectionState {
    selectionBoxOrigin: BookingCalendarSelectionCoordinates;
    selectionBoxTarget: BookingCalendarSelectionCoordinates;
    hold: boolean;
    animation: string;
    selectionBox: boolean;
}
export default class BookingCalendarSelection extends React.Component<BookingCalendarSelectionProps, BookingCalendarSelectionState> {
    private animationInProgress;
    private containerRef;
    constructor(props: any);
    handleTransformBox(): "scaleY(-1) scaleX(-1)" | "scaleY(-1)" | "scaleX(-1)";
    handleMouseLeave(evt: React.MouseEvent<HTMLElement>): void;
    handleMouseUp(evt: React.MouseEvent<HTMLElement>): void;
    handleMouseDown(e: React.MouseEvent<HTMLDivElement>): void;
    private handleMouseMove;
    render(): React.JSX.Element;
}
