"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var React = _interopRequireWildcard(require("react"));
var _classes = require("./classes");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
class BookingCalendarSelection extends React.Component {
  constructor(props) {
    super(props);
    this.animationInProgress = void 0;
    this.containerRef = void 0;
    this.animationInProgress = null;
    this.containerRef = /*#__PURE__*/React.createRef();
    this.state = {
      hold: false,
      selectionBox: false,
      selectionBoxOrigin: [0, 0],
      selectionBoxTarget: [0, 0],
      animation: ''
    };
    this.handleMouseUp = this.handleMouseUp.bind(this);
    this.handleMouseDown = this.handleMouseDown.bind(this);
    this.handleMouseMove = this.handleMouseMove.bind(this);
    this.handleMouseLeave = this.handleMouseLeave.bind(this);
  }
  handleTransformBox() {
    const {
      selectionBoxOrigin,
      selectionBoxTarget
    } = this.state;
    if (selectionBoxOrigin[1] > selectionBoxTarget[1] && selectionBoxOrigin[0] > selectionBoxTarget[0]) {
      return 'scaleY(-1) scaleX(-1)';
    }
    if (selectionBoxOrigin[1] > selectionBoxTarget[1]) {
      return 'scaleY(-1)';
    }
    if (selectionBoxOrigin[0] > selectionBoxTarget[0]) {
      return 'scaleX(-1)';
    }
    return null;
  }
  handleMouseLeave(evt) {
    /*if (this.state.hold) {
      this.setState({
        hold: false,
        animation: 'bookingCalendar__selection--fadeout',
      });
      this.animationInProgress = (setTimeout(() => {
        this.setState({
          selectionBox: false,
          animation: '',
          selectionBoxOrigin: [0, 0],
          selectionBoxTarget: [0, 0],
        });
        this.animationInProgress = null;
      }, 300) as unknown) as number;
    }*/
  }
  handleMouseUp(evt) {
    if (this.state.hold) {
      var _this$props$onSelecte, _this$props;
      const distance = Math.sqrt(Math.pow(this.state.selectionBoxTarget[1] - this.state.selectionBoxOrigin[1], 2) + Math.pow(this.state.selectionBoxTarget[0] - this.state.selectionBoxOrigin[0], 2));
      this.setState({
        hold: false,
        animation: 'bookingCalendar__selection--fadeout'
      });
      this.animationInProgress = setTimeout(() => {
        this.setState({
          selectionBox: false,
          animation: '',
          selectionBoxOrigin: [0, 0],
          selectionBoxTarget: [0, 0]
        });
        this.animationInProgress = null;
      }, 300);
      if (distance < this.props.minSelectionSize) {
        return;
      }
      (_this$props$onSelecte = (_this$props = this.props).onSelected) === null || _this$props$onSelecte === void 0 ? void 0 : _this$props$onSelecte.call(_this$props, {
        origin: this.state.selectionBoxOrigin,
        target: this.state.selectionBoxTarget
      }, evt);
    }
  }
  handleMouseDown(e) {
    var _this$containerRef$cu;
    if (this.props.disabled || e.nativeEvent.button !== 0) {
      return;
    }
    clearTimeout(this.animationInProgress);
    this.animationInProgress = null;
    this.setState({
      selectionBox: false,
      animation: ''
    });
    const bb = (_this$containerRef$cu = this.containerRef.current) === null || _this$containerRef$cu === void 0 ? void 0 : _this$containerRef$cu.getBoundingClientRect();
    this.setState({
      hold: true,
      selectionBoxOrigin: [e.nativeEvent.pageX - bb.x, e.nativeEvent.pageY - bb.y],
      selectionBoxTarget: [e.nativeEvent.pageX - bb.x, e.nativeEvent.pageY - bb.y]
    });
  }
  handleMouseMove(evt) {
    if (this.state.hold && !this.state.selectionBox) {
      this.setState({
        selectionBox: true
      });
    }
    if (this.state.selectionBox && !this.animationInProgress) {
      var _this$containerRef$cu2, _this$props$onSelecti, _this$props2;
      const bb = (_this$containerRef$cu2 = this.containerRef.current) === null || _this$containerRef$cu2 === void 0 ? void 0 : _this$containerRef$cu2.getBoundingClientRect();
      this.setState({
        selectionBoxTarget: [evt.nativeEvent.pageX - (bb === null || bb === void 0 ? void 0 : bb.x), evt.nativeEvent.pageY - (bb === null || bb === void 0 ? void 0 : bb.y)]
      });
      (_this$props$onSelecti = (_this$props2 = this.props).onSelecting) === null || _this$props$onSelecti === void 0 ? void 0 : _this$props$onSelecti.call(_this$props2, {
        origin: this.state.selectionBoxOrigin,
        target: this.state.selectionBoxTarget
      });
    }
  }
  render() {
    const {
      width
    } = this.props;
    const baseStyle = {
      zIndex: 10,
      left: Math.min(this.state.selectionBoxOrigin[0] - window.scrollX, this.state.selectionBoxTarget[0] - window.scrollX),
      top: Math.min(this.state.selectionBoxOrigin[1] - window.scrollY, this.state.selectionBoxTarget[1] - window.scrollY),
      height: Math.abs(this.state.selectionBoxTarget[1] - this.state.selectionBoxOrigin[1] - 1),
      width: Math.abs(this.state.selectionBoxTarget[0] - this.state.selectionBoxOrigin[0] - 1),
      userSelect: 'none'
      // transformOrigin: 'top left',
      // transform: this.handleTransformBox(),
    };

    const boxVisible = Math.sqrt(Math.pow(this.state.selectionBoxTarget[1] - this.state.selectionBoxOrigin[1], 2) + Math.pow(this.state.selectionBoxTarget[0] - this.state.selectionBoxOrigin[0], 2)) > this.props.minSelectionSize;
    return /*#__PURE__*/React.createElement("div", {
      ref: this.containerRef,
      className: _classes.bookingCalendarSelectionDefaultClasses.root,
      style: _objectSpread({
        zIndex: this.state.selectionBox ? 99999 : undefined,
        gridRowEnd: `span ${this.props.dataRowsCount}`,
        gridRowStart: this.props.firstDataRowIndex
      }, width ? {
        width: `${width}px`
      } : {}),
      onMouseDown: this.handleMouseDown,
      onMouseUp: this.handleMouseUp,
      onMouseMove: this.handleMouseMove,
      onMouseLeave: this.handleMouseLeave
    }, boxVisible && this.state.selectionBox && /*#__PURE__*/React.createElement("div", {
      className: `${_classes.bookingCalendarSelectionDefaultClasses.selection} ${this.state.animation}`,
      style: baseStyle
    }, this.props.children));
  }
}
exports.default = BookingCalendarSelection;
//# sourceMappingURL=BookingCalendarSelection.js.map