"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BookingCalendarTimeAxis = BookingCalendarTimeAxis;
var React = _interopRequireWildcard(require("react"));
var _classes = require("./classes");
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function BookingCalendarTimeAxis(props) {
  const {
    className,
    timeAxisItemClassName,
    items,
    getMomentFormatFunction,
    bestStep
  } = props;
  const svgRef = React.useRef();
  return /*#__PURE__*/React.createElement("svg", {
    className: (0, _classnames.default)(_classes.bookingCalendarTimeAxisDefaultClasses.className, className),
    ref: svgRef,
    height: "100"
  }, /*#__PURE__*/React.createElement("g", null, items.map((item, key) => /*#__PURE__*/React.createElement("svg", {
    key: key,
    x: `${item.left * 100}%`
  }, /*#__PURE__*/React.createElement("text", {
    transform: "translate(-7) rotate(90)",
    className: (0, _classnames.default)(_classes.bookingCalendarTimeAxisDefaultClasses.timeAxisItemClassName, timeAxisItemClassName)
  }, item.date.format(getMomentFormatFunction === null || getMomentFormatFunction === void 0 ? void 0 : getMomentFormatFunction(item.date, bestStep)))))));
}
//# sourceMappingURL=BookingCalendarTimeAxis.js.map