/// <reference types="react" />
import moment, { Moment, Duration } from 'moment';
export interface BookingCalendarItemT {
    from: Moment;
    till: Moment;
    id: string | number;
    laneKey?: string | number;
}
export interface BookingCalendarItemWithOriginalIndexT {
    originalIndex: number;
}
export interface BookingCalendarDateRange {
    from: Moment;
    till: Moment;
}
export interface ZoomLevel {
    step: Duration;
    label: React.ReactNode;
}
export declare const defaultGetMomentFormatFunction: (date: Moment, bestStep: Duration) => "MMM Do" | "h:mm a";
export type GetMomentFormatFunctionType = typeof defaultGetMomentFormatFunction;
export declare const defaultGetNewMomentFunction: (date: Date) => moment.Moment;
export type GetNewMomentFunctionType = typeof defaultGetNewMomentFunction;
export declare const defaultGridAvailableSteps: Duration[];
