"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultGridAvailableSteps = exports.defaultGetNewMomentFunction = exports.defaultGetMomentFormatFunction = void 0;
var _moment = _interopRequireDefault(require("moment"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const defaultGetMomentFormatFunction = (date, bestStep) => {
  if (!date || !bestStep) {
    return undefined;
  }
  if (date.valueOf() === date.clone().startOf('day').valueOf()) {
    return 'MMM Do';
  }
  return 'h:mm a';
};
exports.defaultGetMomentFormatFunction = defaultGetMomentFormatFunction;
const defaultGetNewMomentFunction = date => {
  return (0, _moment.default)(date);
};
exports.defaultGetNewMomentFunction = defaultGetNewMomentFunction;
const defaultGridAvailableSteps = [_moment.default.duration(1, 'minute'), _moment.default.duration(5, 'minute'), _moment.default.duration(10, 'minute'), _moment.default.duration(15, 'minute'), _moment.default.duration(20, 'minute'), _moment.default.duration(30, 'minute'), _moment.default.duration(1, 'hour'), _moment.default.duration(2, 'hour'), _moment.default.duration(4, 'hour'), _moment.default.duration(6, 'hour'), _moment.default.duration(8, 'hour'), _moment.default.duration(12, 'hour'), _moment.default.duration(1, 'day')];
exports.defaultGridAvailableSteps = defaultGridAvailableSteps;
//# sourceMappingURL=common.js.map