"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Button = void 0;
var React = _interopRequireWildcard(require("react"));
var _withThemeContext = require("../themeProvider/withThemeContext");
var _reactInk = _interopRequireDefault(require("react-ink"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // Libs
// Misc

const DefaultButtonComponent = /*#__PURE__*/React.forwardRef((props, ref) => /*#__PURE__*/React.createElement("button", _extends({
  ref: ref
  // tslint:disable-next-line:no-any
}, props.buttonProps ? props.buttonProps : {}, props.id && {
  id: props.id
}, {
  className: props.className,
  onClick: props.onClick,
  style: props.style
}), props.children));
class Button extends React.PureComponent {
  constructor(props) {
    super(props);
    this.preventMultipleClickTimer = void 0;
    this.handleClick = this.handleClick.bind(this);
    this.state = {
      disabledAfterClick: false
    };
  }
  render() {
    var _this$props$buttonPro;
    const disabled = this.props.disabled || this.props.disableAfterClick && this.state.disabledAfterClick;
    let btnClassName = (0, _classnames.default)(['guestbell-btn', this.getButtonClassName(), this.props.className, {
      ['guestbell-btn--disabled']: disabled
    }, {
      ['guestbell-btn--circular']: this.props.circular
    }, {
      ['guestbell-btn--small']: this.props.small
    }, {
      ['guestbell-btn--no-shadow']: this.props.noShadow
    }, {
      ['guestbell-btn--blank']: this.props.blank
    }, {
      ['guestbell-btn--unobtrusive']: this.props.unobtrusive
    }, {
      ['guestbell-btn--outlined']: this.props.outlined
    }, {
      ['guestbell-btn--dropdown']: this.props.dropdown
    }, {
      ['guestbell-btn--icon']: this.props.icon
    }, {
      ['guestbell-btn--hero']: this.props.hero
    }, {
      ['guestbell-btn--text']: this.props.text
    }]);
    const button = /*#__PURE__*/React.createElement(this.props.Component, _extends({}, this.props.id && {
      id: this.props.id
    }, {
      onClick: this.handleClick,
      buttonProps: _objectSpread(_objectSpread({}, this.props.buttonProps), {}, {
        tabIndex: !disabled ? (_this$props$buttonPro = this.props.buttonProps) === null || _this$props$buttonPro === void 0 ? void 0 : _this$props$buttonPro.tabIndex : -1
      }),
      className: btnClassName,
      style: this.props.style
    }), !this.props.noRipples && !disabled && _reactInk.default && /*#__PURE__*/React.createElement(_reactInk.default, null), this.props.children);
    if (this.props.tooltip && !this.props.disableTooltip) {
      var _document;
      const Tippy = require('@tippy.js/react').default;
      return /*#__PURE__*/React.createElement(Tippy, _extends({
        content: this.props.tooltip,
        placement: "bottom",
        animation: "scale-subtle",
        arrow: false,
        duration: 200,
        delay: [75, 0],
        distance: 8,
        interactive: true,
        appendTo: (_document = document) === null || _document === void 0 ? void 0 : _document.body
      }, this.props.tooltipProps), button);
    }
    return button;
  }
  componentWillUnmount() {
    clearTimeout(this.preventMultipleClickTimer);
  }
  handleClick(e) {
    if (this.props.preventsDefault) {
      e.preventDefault();
    }
    if (!this.state.disabledAfterClick && !this.props.disabled) {
      this.props.onClick && this.props.onClick(e);
      if (this.props.disableAfterClickMs !== 0) {
        this.setState({
          disabledAfterClick: true
        });
        this.preventMultipleClickTimer = setTimeout(() => {
          this.setState({
            disabledAfterClick: false
          });
        }, this.props.disableAfterClickMs);
      }
    }
  }
  getButtonClassName() {
    return this.props.type && 'guestbell-btn-' + this.props.type;
  }
}
exports.Button = Button;
Button.defaultProps = {
  disabled: false,
  className: '',
  onClick: () => null,
  circular: false,
  noRipples: false,
  small: false,
  disableAfterClickMs: 100,
  disableAfterClick: false,
  Component: DefaultButtonComponent,
  buttonProps: {
    type: 'button',
    role: 'button',
    tabIndex: 0
  },
  type: 'none',
  preventsDefault: true
};
var _default = (0, _withThemeContext.withThemeContext)(Button, 'button');
exports.default = _default;
//# sourceMappingURL=Button.js.map