import * as React from 'react';
import { BaseInputProps, BaseInput, BaseInputState } from '../base/input/BaseInput';
export interface CheckboxProps extends BaseInputProps<HTMLInputElement> {
    onChecked?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onChange?: never;
    type?: string;
    checked?: boolean;
    supportsIndeterminate?: boolean;
}
export interface CheckboxState extends BaseInputState {
    checked: boolean;
}
export declare class CheckboxRaw extends BaseInput<CheckboxProps, CheckboxState, HTMLInputElement> {
    static defaultProps: CheckboxProps;
    constructor(props: CheckboxProps);
    componentDidMount(): void;
    componentDidUpdate(oldProps: CheckboxProps): void;
    render(): React.JSX.Element;
    private handleChecked;
    protected handleKeyDown(e: React.KeyboardEvent<HTMLInputElement>): void;
}
export declare const Checkbox: React.ForwardRefExoticComponent<CheckboxProps & React.RefAttributes<CheckboxRaw>>;
export default Checkbox;
