"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.CheckboxRaw = exports.Checkbox = void 0;
var React = _interopRequireWildcard(require("react"));
var _InputGroup = _interopRequireDefault(require("../inputGroup/InputGroup"));
var _BaseInput = require("../base/input/BaseInput");
var _classnames = _interopRequireDefault(require("classnames"));
var _withFormContext = require("../form/withFormContext");
var _withThemeContext = require("../themeProvider/withThemeContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // Libs
// Misc
class CheckboxRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props, false);
    this.state = Object.assign(this.state, {
      checked: Boolean(props.checked),
      isValid: props.required ? props.checked : true,
      errors: props.required && !props.checked ? [this.getTranslations(_BaseInput.defaultBaseTranslations).required] : []
    });
    this.handleChecked = this.handleChecked.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.subscribeSelf(props);
  }
  componentDidMount() {
    var _this$inputRef$curren, _super$componentDidMo;
    const finalIndeterminate = Boolean(this.props.supportsIndeterminate && typeof this.props.checked !== 'boolean');
    if (typeof this.props.checked !== 'boolean' && this.inputRef.current && ((_this$inputRef$curren = this.inputRef.current) === null || _this$inputRef$curren === void 0 ? void 0 : _this$inputRef$curren.indeterminate) !== finalIndeterminate) {
      this.inputRef.current.indeterminate = finalIndeterminate;
    }
    (_super$componentDidMo = super.componentDidMount) === null || _super$componentDidMo === void 0 ? void 0 : _super$componentDidMo.call(this);
  }
  componentDidUpdate(oldProps) {
    var _this$inputRef$curren2;
    if (this.props.checked !== undefined && this.props.checked !== this.state.checked) {
      this.setState({
        checked: this.props.checked
      });
      if (this.props.checked) {
        this.setValid();
      } else {
        if (this.props.required) {
          this.setInvalid([this.getTranslations(_BaseInput.defaultBaseTranslations).required]);
        }
      }
    }
    if (oldProps.required !== this.props.required) {
      if (this.props.required && !this.props.checked) {
        this.setInvalid([this.getTranslations(_BaseInput.defaultBaseTranslations).required]);
      } else {
        this.setValid();
      }
    }
    const finalIndeterminate = Boolean(this.props.supportsIndeterminate && typeof this.props.checked !== 'boolean');
    if (this.props.supportsIndeterminate && ((_this$inputRef$curren2 = this.inputRef.current) === null || _this$inputRef$curren2 === void 0 ? void 0 : _this$inputRef$curren2.indeterminate) !== finalIndeterminate) {
      this.inputRef.current.indeterminate = finalIndeterminate;
    }
  }
  render() {
    const containerClassName = (0, _classnames.default)(['input__base checkbox-input', this.getValidationClass(), this.props.className, {
      ['checkbox-input--with-label']: Boolean(this.props.label)
    }, {
      ['checkbox-input--disabled']: this.props.disabled
    }]);
    const input = /*#__PURE__*/React.createElement("input", _extends({}, this.props.id && {
      id: this.props.id
    }, {
      ref: this.inputRef,
      value: this.props.value || '',
      type: "checkbox",
      required: this.props.required,
      checked: this.state.checked ?? false,
      onChange: this.handleChecked,
      onBlur: this.handleBlur,
      onFocus: this.handleFocus,
      onKeyDown: this.handleKeyDown,
      tabIndex: this.props.disabled ? -1 : 0
    }));
    return /*#__PURE__*/React.createElement(_InputGroup.default, {
      title: this.props.title,
      tooltip: this.props.tooltip,
      className: this.props.inputGroupClassName
    }, /*#__PURE__*/React.createElement("div", {
      className: containerClassName,
      ref: this.containerRef
    }, this.props.title && !this.props.label && input, !this.props.title && !this.props.label && this.renderTooltip(input), this.renderDefaultValidation(), this.props.label && /*#__PURE__*/React.createElement("label", {
      className: "checkbox-input__label"
    }, input, this.renderLabel())));
  }
  handleChecked(e) {
    if (!this.props.disabled) {
      this.props.onChecked && this.props.onChecked(e);
      this.setState({
        checked: !this.state.checked
      });
      if (!this.state.checked) {
        this.setValid();
      } else {
        if (this.props.required) {
          this.setInvalid([this.getTranslations(_BaseInput.defaultBaseTranslations).required]);
        }
      }
    }
  }
  handleKeyDown(e) {
    if (!this.props.disabled) {
      if (e.key === 'Enter') {
        var _this$inputRef$curren3;
        (_this$inputRef$curren3 = this.inputRef.current) === null || _this$inputRef$curren3 === void 0 ? void 0 : _this$inputRef$curren3.click();
      }
    }
  }
}
exports.CheckboxRaw = CheckboxRaw;
CheckboxRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  // checked: false,
});
const Checkbox = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(CheckboxRaw), 'checkbox');
exports.Checkbox = Checkbox;
var _default = Checkbox;
exports.default = _default;
//# sourceMappingURL=Checkbox.js.map