import * as React from 'react';
import { CollapseProps } from '@mui/material/Collapse';
import { ThemeContextProps } from '../themeProvider/ThemeContext';
export type DropdownProps = React.PropsWithChildren<ThemeContextProps & {
    id?: string;
    header?: JSX.Element | string;
    className?: string;
    submenuClassName?: string;
    headerClassName?: string;
    notificationCount?: number;
    WrapperTag?: keyof JSX.IntrinsicElements;
    shouldHandleClick?: boolean;
    showArrow?: boolean;
    onClick?: (e: React.MouseEvent, isVisible: boolean) => void;
    onShow?: () => void;
    onHide?: () => void;
    disabled?: boolean;
    inline?: boolean;
    collapseProps?: Partial<CollapseProps>;
}>;
export interface DropdownState {
    isDropdownVisible: boolean;
}
export declare const Dropdown: React.FC<DropdownProps>;
declare const _default: React.ForwardRefExoticComponent<ThemeContextProps & {
    id?: string;
    header?: string | JSX.Element;
    className?: string;
    submenuClassName?: string;
    headerClassName?: string;
    notificationCount?: number;
    WrapperTag?: keyof JSX.IntrinsicElements;
    shouldHandleClick?: boolean;
    showArrow?: boolean;
    onClick?: (e: React.MouseEvent<Element, MouseEvent>, isVisible: boolean) => void;
    onShow?: () => void;
    onHide?: () => void;
    disabled?: boolean;
    inline?: boolean;
    collapseProps?: Partial<CollapseProps>;
} & {
    children?: React.ReactNode;
} & React.RefAttributes<React.FC<DropdownProps>>>;
export default _default;
