import * as React from 'react';
import { FormContextState, FormComponentContextState, ComponentsDict } from './FormContext';
import { ThemeContextProps } from '../themeProvider/ThemeContext';
export type FormProps = React.PropsWithChildren<ThemeContextProps & {
    id?: string;
    className?: string;
    noValidate?: boolean;
    onSubmit?: () => void;
    extraComponents?: ComponentsDict;
    component?: keyof JSX.IntrinsicElements;
    onValidChanged?: (isValid: boolean, errors?: FormComponentContextState[]) => void;
}>;
export interface FormState {
    contextState: FormContextState;
}
export declare class Form extends React.PureComponent<FormProps, FormState> {
    static defaultProps: {
        noValidate: boolean;
        showExpandAll: boolean;
        component: keyof JSX.IntrinsicElements;
    };
    constructor(props: FormProps);
    componentDidUpdate(prevProps: Readonly<FormProps>, prevState: Readonly<FormState>, snapshot?: any): void;
    disableComponents(): void;
    enableComponents(): void;
    touchAll(): void;
    unTouchAll(): void;
    render(): React.JSX.Element;
    private mergeContext;
    private onSubmit;
    private subscribe;
    private unSubscribe;
    private getIsFormValid;
    private updateCallback;
}
declare const _default: React.ForwardRefExoticComponent<ThemeContextProps & {
    id?: string;
    className?: string;
    noValidate?: boolean;
    onSubmit?: () => void;
    extraComponents?: ComponentsDict;
    component?: keyof JSX.IntrinsicElements;
    onValidChanged?: (isValid: boolean, errors?: FormComponentContextState[]) => void;
} & {
    children?: React.ReactNode;
} & React.RefAttributes<Form>>;
export default _default;
