"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Form = void 0;
var React = _interopRequireWildcard(require("react"));
var _FormContext = require("./FormContext");
var _withThemeContext = require("../themeProvider/withThemeContext");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // Libs
// Misc
class Form extends React.PureComponent {
  constructor(props) {
    super(props);
    this.onSubmit = e => {
      e.preventDefault();
      this.props.onSubmit && this.props.onSubmit();
    };
    this.subscribe = this.subscribe.bind(this);
    this.unSubscribe = this.unSubscribe.bind(this);
    this.updateCallback = this.updateCallback.bind(this);
    this.disableComponents = this.disableComponents.bind(this);
    this.enableComponents = this.enableComponents.bind(this);
    this.state = {
      contextState: {
        subscribe: this.subscribe,
        unSubscribe: this.unSubscribe,
        isFormValid: true,
        updateCallback: this.updateCallback,
        disableComponents: this.disableComponents,
        enableComponents: this.enableComponents,
        components: {}
      }
    };
  }
  componentDidUpdate(prevProps, prevState, snapshot) {
    var _this$state$contextSt, _prevState$contextSta;
    if (((_this$state$contextSt = this.state.contextState) === null || _this$state$contextSt === void 0 ? void 0 : _this$state$contextSt.isFormValid) !== (prevState === null || prevState === void 0 ? void 0 : (_prevState$contextSta = prevState.contextState) === null || _prevState$contextSta === void 0 ? void 0 : _prevState$contextSta.isFormValid)) {
      var _this$props$onValidCh, _this$props, _this$state$contextSt2;
      const componentsWithErrors = this.state.contextState ? Object.keys(this.state.contextState.components).map(key => this.state.contextState.components[key]).filter(component => {
        if (!component.validation.isValid && !component.validation.name) {
          console.warn(component, 'Has validation error. FormValidationSummary is present but the component has no validation name');
        }
        return !component.validation.isValid;
      }) : [];
      (_this$props$onValidCh = (_this$props = this.props).onValidChanged) === null || _this$props$onValidCh === void 0 ? void 0 : _this$props$onValidCh.call(_this$props, (_this$state$contextSt2 = this.state.contextState) === null || _this$state$contextSt2 === void 0 ? void 0 : _this$state$contextSt2.isFormValid, componentsWithErrors);
    }
  }
  disableComponents() {
    const components = _objectSpread(_objectSpread({}, this.state.contextState.components), this.props.extraComponents);
    Object.keys(components).forEach(key => {
      const component = components[key];
      component && component.componentApi && component.componentApi.disableComponent && component.componentApi.disableComponent();
    });
  }
  enableComponents() {
    const components = _objectSpread(_objectSpread({}, this.state.contextState.components), this.props.extraComponents);
    Object.keys(components).forEach(key => {
      const component = components[key];
      component && component.componentApi && component.componentApi.enableComponent && component.componentApi.enableComponent();
    });
  }
  touchAll() {
    const components = _objectSpread(_objectSpread({}, this.state.contextState.components), this.props.extraComponents);
    Object.keys(components).forEach(key => {
      const component = components[key];
      component && component.componentApi && component.componentApi.touch && component.componentApi.touch();
    });
  }
  unTouchAll() {
    const components = _objectSpread(_objectSpread({}, this.state.contextState.components), this.props.extraComponents);
    Object.keys(components).forEach(key => {
      const component = components[key];
      component && component.componentApi && component.componentApi.unTouch && component.componentApi.unTouch();
    });
  }
  render() {
    return /*#__PURE__*/React.createElement(this.props.component, _extends({}, this.props.id && {
      id: this.props.id
    }, {
      noValidate: true,
      role: "form",
      className: `input__form validation-form ${this.props.className ? this.props.className : ''}`,
      onSubmit: this.onSubmit
    }), /*#__PURE__*/React.createElement(_FormContext.FormContextProvider, {
      value: this.mergeContext()
    }, this.props.children));
  }
  mergeContext() {
    if (!this.props.extraComponents) {
      return this.state.contextState;
    }
    const isFormValid = this.state.contextState.isFormValid && this.getIsFormValid(this.props.extraComponents);
    return _objectSpread(_objectSpread({}, this.state.contextState), {}, {
      components: _objectSpread(_objectSpread({}, this.state.contextState.components), this.props.extraComponents),
      isFormValid
    });
  }
  subscribe(componentId, componentState) {
    if (componentId) {
      this.setState(previousState => {
        let components = Object.assign({}, previousState.contextState.components);
        if (componentState) {
          components[componentId] = componentState;
        }
        let isFormValid = this.getIsFormValid(components);
        return {
          contextState: _objectSpread(_objectSpread({}, previousState.contextState), {}, {
            components,
            isFormValid
          })
        };
      });
    }
  }
  unSubscribe(componentId) {
    if (componentId) {
      this.setState(previousState => {
        let components = Object.assign({}, previousState.contextState.components);
        delete components[componentId];
        let isFormValid = this.getIsFormValid(components);
        return {
          contextState: _objectSpread(_objectSpread({}, previousState.contextState), {}, {
            components,
            isFormValid
          })
        };
      });
    }
  }
  getIsFormValid() {
    let components = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.contextState.components;
    let initialValid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    let isFormValid = initialValid;
    Object.keys(components).forEach(key => {
      const component = components[key];
      if (component && component.validation && !component.validation.isValid) {
        isFormValid = false;
      }
    });
    return isFormValid;
  }
  updateCallback(componentId, componentState) {
    this.setState(previousState => {
      let components = Object.assign({}, previousState.contextState.components);
      const previousComponent = components[componentId];
      if (componentState && previousComponent) {
        components[componentId] = _objectSpread(_objectSpread(_objectSpread({}, previousComponent), componentState), {}, {
          validation: _objectSpread(_objectSpread({}, previousComponent.validation), componentState.validation)
        });
      }
      let isFormValid = this.getIsFormValid(components);
      return {
        contextState: _objectSpread(_objectSpread({}, this.state.contextState), {}, {
          components,
          isFormValid
        })
      };
    });
  }
}
exports.Form = Form;
Form.defaultProps = {
  noValidate: false,
  showExpandAll: true,
  component: 'form'
};
var _default = (0, _withThemeContext.withThemeContext)(Form, 'form');
exports.default = _default;
//# sourceMappingURL=Form.js.map