"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormValidationSummaryRaw = exports.FormValidationSummary = exports.DefaultComponent = void 0;
var React = _interopRequireWildcard(require("react"));
var _Guid = _interopRequireDefault(require("../utils/Guid"));
var _withFormContext = require("./withFormContext");
var _Button = require("./../button/Button");
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var ArrowIcon = function ArrowIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M12 8c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm8.94 3A8.994 8.994 0 0 0 13 3.06V1h-2v2.06A8.994 8.994 0 0 0 3.06 11H1v2h2.06A8.994 8.994 0 0 0 11 20.94V23h2v-2.06A8.994 8.994 0 0 0 20.94 13H23v-2h-2.06zM12 19c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
  }));
};
ArrowIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
const DefaultComponent = props => /*#__PURE__*/React.createElement(React.Fragment, null, props.componentsWithErrors.map((component, index) => {
  return /*#__PURE__*/React.createElement("div", {
    key: index,
    className: "formValidationSummary__item"
  }, /*#__PURE__*/React.createElement("div", {
    className: "formValidationSummary__item__header"
  }, component.validation.name ? component.validation.name : 'unknown'), /*#__PURE__*/React.createElement("div", {
    className: "formValidationSummary__item__errors"
  }, component.validation.errors && component.validation.errors.map((err, errIndex) => /*#__PURE__*/React.createElement("span", {
    className: "formValidationSummary__item__error",
    key: errIndex
  }, err))), /*#__PURE__*/React.createElement("div", {
    style: {
      flex: 'auto'
    }
  }), component.componentApi && component.componentApi.focus && component.componentApi.scrollTo && /*#__PURE__*/React.createElement(_Button.Button, {
    icon: true,
    className: "formValidationSummary__item__locate-button",
    circular: true,
    type: "error",
    small: true,
    blank: true,
    onClick: () => {
      component.componentApi.scrollTo();
      component.componentApi.focus();
    }
  }, /*#__PURE__*/React.createElement(ArrowIcon, null)));
}));
exports.DefaultComponent = DefaultComponent;
class FormValidationSummaryRaw extends React.PureComponent {
  constructor() {
    super(...arguments);
    this.componentId = (0, _Guid.default)();
  }
  render() {
    const componentsWithErrors = this.props.formContext ? Object.keys(this.props.formContext.components).map(key => this.props.formContext.components[key]).filter(component => {
      if (!component.validation.isValid && !component.validation.name) {
        console.warn(component, 'Has validation error. FormValidationSummary is present but the component has no validation name');
      }
      return !component.validation.isValid;
    }) : [];
    const containerClassName = (0, _classnames.default)(this.props.containerClassName);
    const headerClassName = (0, _classnames.default)(this.props.headerClassName);
    const footerClassName = (0, _classnames.default)(this.props.footerClassName);
    return componentsWithErrors.length > 0 && /*#__PURE__*/React.createElement("div", {
      className: containerClassName
    }, this.props.title && /*#__PURE__*/React.createElement("div", {
      className: headerClassName
    }, this.props.title), /*#__PURE__*/React.createElement(this.props.Component, {
      componentsWithErrors: componentsWithErrors
    }), this.props.footer && /*#__PURE__*/React.createElement("div", {
      className: footerClassName
    }, this.props.footer));
  }
}
exports.FormValidationSummaryRaw = FormValidationSummaryRaw;
FormValidationSummaryRaw.defaultProps = {
  title: 'Hang on',
  footer: '... needs fixing',
  Component: DefaultComponent,
  containerClassName: 'formValidationSummary',
  headerClassName: 'formValidationSummary__header',
  footerClassName: 'formValidationSummary__footer'
};
const FormValidationSummary = (0, _withFormContext.withFormContext)(FormValidationSummaryRaw);
exports.FormValidationSummary = FormValidationSummary;
//# sourceMappingURL=FormValidationSummary.js.map