import * as React from 'react';
import { BaseInputProps, BaseInputState, BaseInput } from '../base/input/BaseInput';
import { ThemeContextProps } from '../themeProvider/ThemeContext';
export type InputGroupProps = React.PropsWithChildren<Pick<BaseInputProps<never>, 'title' | 'className' | 'tooltip' | 'formContext'> & ThemeContextProps> & {
    bodyClassName?: string;
    headerClassName?: string;
};
export interface InputGroupState extends BaseInputState {
}
export declare class InputGroup extends BaseInput<InputGroupProps, InputGroupState, never> {
    static defaultProps: any;
    constructor(props: InputGroupProps);
    render(): string | number | boolean | React.JSX.Element | React.ReactFragment;
}
declare const _default: React.ForwardRefExoticComponent<Pick<BaseInputProps<never>, "formContext" | "className" | "tooltip" | "title"> & ThemeContextProps & {
    children?: React.ReactNode;
} & {
    bodyClassName?: string;
    headerClassName?: string;
} & React.RefAttributes<InputGroup>>;
export default _default;
