"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.InputHeaderRaw = exports.InputHeader = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Button = require("../button/Button");
var _Guid = _interopRequireDefault(require("../utils/Guid"));
var _dropdown = require("../dropdown");
var _Collapse = _interopRequireDefault(require("@mui/material/Collapse"));
var _withInputHeaderContext = require("./withInputHeaderContext");
var _withThemeContext = require("../themeProvider/withThemeContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // Libs
// Misc
var MoreIcon = function MoreIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M12 8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
  }));
};
MoreIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var PlusIcon = function PlusIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z"
  }));
};
PlusIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
const CollapseExpandButtonComponent = props => /*#__PURE__*/React.createElement("a", {
  className: props.className,
  onClick: props.onClick,
  href: "#"
}, props.children);
class InputHeaderRaw extends React.PureComponent {
  constructor(props) {
    super(props);
    this.componentId = (0, _Guid.default)();
    this.toggleClick = () => this.toggle();
    this.mainButtonClick = e => {
      if (this.props.stopsPropagation) {
        e.stopPropagation();
      }
    };
    this.containerClick = e => e.stopPropagation();
    this.expandAllClick = () => {
      Object.keys(this.state.inputHeaderContext.components).forEach(key => {
        const component = this.state.inputHeaderContext.components[key];
        component.componentApi.expand();
      });
    };
    this.collapseAllClick = () => {
      Object.keys(this.state.inputHeaderContext.components).forEach(key => {
        const component = this.state.inputHeaderContext.components[key];
        component.componentApi.collapse();
      });
    };
    this.state = {
      collapsed: props.collapsedDefault,
      inputHeaderContext: {
        registerInputHeader: this.registerInputHeader,
        unregisterInputHeader: this.unregisterInputHeader,
        stateChanged: () => this.forceUpdate(),
        components: {}
      }
    };
    this.registerInputHeader = this.registerInputHeader.bind(this);
    this.unregisterInputHeader = this.unregisterInputHeader.bind(this);
    this.expand = this.expand.bind(this);
    this.collapse = this.collapse.bind(this);
    this.toggle = this.toggle.bind(this);
  }
  componentWillUnmount() {
    if (!this.props.ignoreContext && this.props.inputHeaderContext) {
      this.props.inputHeaderContext.unregisterInputHeader(this.componentId);
    }
  }
  componentDidMount() {
    if (!this.props.ignoreContext && this.props.inputHeaderContext) {
      this.props.inputHeaderContext.registerInputHeader(this.componentId, {
        componentId: this.componentId,
        componentApi: {
          expand: this.expand,
          collapse: this.collapse,
          toggle: this.toggle
        },
        props: _objectSpread(_objectSpread({}, {}), this.props),
        state: _objectSpread(_objectSpread({}, {}), this.state)
      });
    }
  }
  expand() {
    this.props.collapsible && this.setState({
      collapsed: false
    }, () => {
      var _this$props$inputHead, _this$props$inputHead2, _this$props$onChange, _this$props, _this$props$onExpande, _this$props2;
      (_this$props$inputHead = this.props.inputHeaderContext) === null || _this$props$inputHead === void 0 ? void 0 : (_this$props$inputHead2 = _this$props$inputHead.stateChanged) === null || _this$props$inputHead2 === void 0 ? void 0 : _this$props$inputHead2.call(_this$props$inputHead);
      (_this$props$onChange = (_this$props = this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props, true);
      (_this$props$onExpande = (_this$props2 = this.props).onExpanded) === null || _this$props$onExpande === void 0 ? void 0 : _this$props$onExpande.call(_this$props2);
    });
  }
  collapse() {
    this.props.collapsible && this.setState({
      collapsed: true
    }, () => {
      var _this$props$inputHead3, _this$props$inputHead4, _this$props$onChange2, _this$props3, _this$props$onCollaps, _this$props4;
      (_this$props$inputHead3 = this.props.inputHeaderContext) === null || _this$props$inputHead3 === void 0 ? void 0 : (_this$props$inputHead4 = _this$props$inputHead3.stateChanged) === null || _this$props$inputHead4 === void 0 ? void 0 : _this$props$inputHead4.call(_this$props$inputHead3);
      (_this$props$onChange2 = (_this$props3 = this.props).onChange) === null || _this$props$onChange2 === void 0 ? void 0 : _this$props$onChange2.call(_this$props3, false);
      (_this$props$onCollaps = (_this$props4 = this.props).onCollapsed) === null || _this$props$onCollaps === void 0 ? void 0 : _this$props$onCollaps.call(_this$props4);
    });
  }
  toggle() {
    this.props.collapsible && this.setState({
      collapsed: !this.state.collapsed
    }, () => {
      var _this$props$inputHead5, _this$props$inputHead6, _this$props$onChange3, _this$props5;
      (_this$props$inputHead5 = this.props.inputHeaderContext) === null || _this$props$inputHead5 === void 0 ? void 0 : (_this$props$inputHead6 = _this$props$inputHead5.stateChanged) === null || _this$props$inputHead6 === void 0 ? void 0 : _this$props$inputHead6.call(_this$props$inputHead5);
      (_this$props$onChange3 = (_this$props5 = this.props).onChange) === null || _this$props$onChange3 === void 0 ? void 0 : _this$props$onChange3.call(_this$props5, this.state.collapsed);
      if (this.state.collapsed) {
        var _this$props$onCollaps2, _this$props6;
        (_this$props$onCollaps2 = (_this$props6 = this.props).onCollapsed) === null || _this$props$onCollaps2 === void 0 ? void 0 : _this$props$onCollaps2.call(_this$props6);
      }
      if (!this.state.collapsed) {
        var _this$props$onExpande2, _this$props7;
        (_this$props$onExpande2 = (_this$props7 = this.props).onExpanded) === null || _this$props$onExpande2 === void 0 ? void 0 : _this$props$onExpande2.call(_this$props7);
      }
    });
  }
  render() {
    var _this$props$extraButt;
    const collapsed = this.props.collapsed !== undefined ? !this.props.collapsed : !this.state.collapsed;
    const showButtons = Boolean(this.props.mainButton || ((_this$props$extraButt = this.props.extraButtons) === null || _this$props$extraButt === void 0 ? void 0 : _this$props$extraButt.length) || this.props.collapsible);
    const ButtonContainer = this.props.ButtonsContainer ?? 'div';
    return /*#__PURE__*/React.createElement("div", {
      className: `input__header ` + (this.props.className ? this.props.className : '') + ' ' + this.getTypeClass()
    }, /*#__PURE__*/React.createElement("div", {
      className: (0, _classnames.default)('input__header__top', {
        'input__header__top--tall': this.props.showExpandAll
      }, {
        'input__header__top--no-bg': this.props.noBg
      }, {
        'input__header__top--clickable': this.props.collapsible && this.props.shouldToggleCollapseOnHeaderClick
      }, this.props.headerClassName),
      role: this.props.collapsible && this.props.shouldToggleCollapseOnHeaderClick ? 'button' : undefined,
      onClick: this.props.collapsible && this.props.shouldToggleCollapseOnHeaderClick ? this.toggleClick : undefined
    }, /*#__PURE__*/React.createElement("div", {
      className: 'input__header__top__header-container '
    }, this.props.icon && /*#__PURE__*/React.createElement("div", {
      className: "input__header__icon line-height--0"
    }, this.props.icon), this.props.title && /*#__PURE__*/React.createElement("div", {
      className: "input__header__title"
    }, this.renderTitle())), this.props.subTitle && /*#__PURE__*/React.createElement("div", {
      className: "input__header__sub-title"
    }, this.props.subTitle), showButtons && /*#__PURE__*/React.createElement(ButtonContainer, {
      className: "input__header__top__button-container",
      onClick: this.mainButtonClick
    }, this.props.mainButton && this.props.mainButton, this.props.extraButtons ? /*#__PURE__*/React.createElement(_dropdown.Dropdown, {
      header: /*#__PURE__*/React.createElement(_Button.Button, _extends({
        blank: true,
        circular: true
      }, this.props.extraButtonsButtonProps), /*#__PURE__*/React.createElement(MoreIcon, null)),
      showArrow: false,
      headerClassName: 'line-height--0',
      className: ''
    }, this.renderExtraButtons()) : null, this.props.collapsible && /*#__PURE__*/React.createElement(_Button.Button, _extends({
      circular: true,
      blank: true,
      className: `input__header__collapse-button line-height--0 ${this.state.collapsed ? 'collapsed' : ''}`
    }, this.props.collapseButtonsButtonProps, {
      onClick: this.toggleClick
    }), /*#__PURE__*/React.createElement(PlusIcon, null))), this.props.showExpandAll && Object.keys(this.state.inputHeaderContext.components).length > 0 && this.renderCollapseExpandAll()), /*#__PURE__*/React.createElement("div", {
      className: 'input__header__bottom ' + (this.props.contentClassName ? this.props.contentClassName : '')
    }, this.props.collapsible ? /*#__PURE__*/React.createElement(_Collapse.default
    //this was here for some reason but it's messing with aria
    //collapsedHeight={'0.0001px'}
    , {
      in: collapsed,
      mountOnEnter: this.props.mountOnEnter,
      unmountOnExit: this.props.unmountOnExit,
      "aria-expanded": collapsed ? 'false' : true
    }, this.props.children) : this.props.children));
  }
  registerInputHeader(componentId, component) {
    this.setState(previousState => {
      let components = Object.assign({}, previousState.inputHeaderContext.components);
      components[componentId] = component;
      return {
        inputHeaderContext: _objectSpread(_objectSpread({}, previousState.inputHeaderContext), {}, {
          components
        })
      };
    });
  }
  unregisterInputHeader(componentId) {
    this.setState(previousState => {
      let components = Object.assign({}, previousState.inputHeaderContext.components);
      delete components[componentId];
      return {
        inputHeaderContext: _objectSpread(_objectSpread({}, previousState.inputHeaderContext), {}, {
          components
        })
      };
    });
  }
  getTypeClass() {
    switch (this.props.type) {
      case 'hero':
        return 'input__header--hero';
      case 'small':
        return 'input__header--small';
      default:
        return '';
    }
  }
  renderExtraButtons() {
    let arr = [];
    if (typeof this.props.extraButtons === 'function') {
      arr = this.props.extraButtons;
    } else {
      arr = this.props.extraButtons;
    }
    return arr.map((extraButton, index) => /*#__PURE__*/React.createElement("li", {
      key: index
    }, extraButton));
  }
  renderCollapseExpandAll() {
    let allCollapsed = true;
    let allExpanded = true;
    Object.keys(this.state.inputHeaderContext.components).forEach(key => {
      const component = this.state.inputHeaderContext.components[key];
      if (component && component.props.collapsible) {
        if (component.state.collapsed) {
          allExpanded = false;
        } else {
          allCollapsed = false;
        }
      }
    });
    return /*#__PURE__*/React.createElement("div", {
      className: "input__header__expand-collapse--all",
      onClick: this.containerClick
    }, (allCollapsed || !allExpanded) && /*#__PURE__*/React.createElement(_Button.Button, {
      noRipples: true,
      small: true,
      className: allExpanded || !allCollapsed ? 'mr-2' : '',
      onClick: this.expandAllClick,
      blank: true,
      Component: CollapseExpandButtonComponent
    }, "Expand all"), (allExpanded || !allCollapsed) && /*#__PURE__*/React.createElement(_Button.Button, {
      noRipples: true,
      small: true,
      onClick: this.collapseAllClick,
      blank: true,
      Component: CollapseExpandButtonComponent
    }, "Collapse all"));
  }
  renderTitle() {
    if (!this.props.tooltip) {
      return this.props.title;
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, this.props.title, this.renderTooltip());
  }
  renderTooltip() {
    let content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : /*#__PURE__*/React.createElement("span", {
      className: "label--help-icon"
    }, "?");
    if (this.props.tooltip) {
      var _document;
      const Tippy = require('@tippy.js/react').default;
      return /*#__PURE__*/React.createElement(Tippy, _extends({
        content: this.props.tooltip,
        placement: "bottom",
        animation: "scale-subtle",
        arrow: false,
        duration: 200,
        delay: [75, 0],
        distance: 8,
        interactive: true,
        appendTo: (_document = document) === null || _document === void 0 ? void 0 : _document.body,
        trigger: "mouseenter focus"
      }, this.props.tooltipProps), /*#__PURE__*/React.createElement("span", {
        tabIndex: 0
      }, content));
    }
    return content;
  }
}
exports.InputHeaderRaw = InputHeaderRaw;
InputHeaderRaw.defaultProps = {
  ignoreContext: false,
  showExpandAll: false,
  collapsedDefault: true,
  type: 'standard',
  noBg: false,
  shouldToggleCollapseOnHeaderClick: false,
  stopsPropagation: true,
  ButtonsContainer: 'div'
};
const InputHeader = (0, _withThemeContext.withThemeContext)((0, _withInputHeaderContext.withInputHeaderContext)(InputHeaderRaw), 'inputHeader');
exports.InputHeader = InputHeader;
var _default = InputHeader;
exports.default = _default;
//# sourceMappingURL=InputHeader.js.map