import * as React from 'react';
import { SelectValue } from '../select/Select';
import { BaseInputProps, BaseInputState, BaseInput } from '../base/input/BaseInput';
export interface MoneyWithCurrency {
    value: number | undefined;
    currency: SelectValue;
}
export declare const defaultMoneyTranslations: {
    cannotRemoveDefaultCurrency: string;
    removePrice: string;
    addPrice: string;
    addNewCurrency: string;
    required: string;
};
export type MoneyTranslations = Partial<typeof defaultMoneyTranslations>;
export interface MoneyProps extends BaseInputProps<never, MoneyTranslations> {
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onPricesChange: (prices: MoneyWithCurrency[]) => void;
    allowMultiple?: boolean;
    currencies: SelectValue[];
    prices: MoneyWithCurrency[];
    disableDelete?: boolean;
}
export interface MoneyState extends BaseInputState {
}
export declare class MoneyRaw extends BaseInput<MoneyProps, MoneyState, never, MoneyTranslations> {
    static defaultProps: {
        theme?: import("../../types/Theme").Theme;
        id?: string;
        disabled?: boolean;
        className?: string;
        label?: string | JSX.Element;
        tooltip?: string | JSX.Element;
        tooltipProps?: import("@tippy.js/react").TippyProps;
        value?: string;
        onChange?: (e: React.ChangeEvent<never>, isValid: boolean) => void;
        required?: boolean;
        customValidators?: import("../..").IBaseValidator[];
        validators?: import("../..").ValidatorTypes[];
        noValidate?: boolean;
        validationName?: string;
        touchOn?: "focus" | "blur";
        ignoreContext?: boolean;
        onTheFlightValidate?: (value: string) => boolean;
        onFocus?: () => void;
        onBlur?: () => void;
        onSuggestionsClosed?: () => void;
        onSuggestionsOpened?: () => void;
        onClick?: (e: React.MouseEvent<Element, MouseEvent>) => void;
        title?: string | JSX.Element;
        onKeyDown?: (e: React.KeyboardEvent<HTMLElement>) => void;
        errors?: import("../base/input/BaseInput").ValidationError[];
        onErrorsChanged?: (errors: import("../base/input/BaseInput").ValidationError[]) => void;
        showValidation?: boolean;
        reRendersWhenContextChanges?: boolean;
        defaultTouched?: boolean;
        translations?: Partial<{
            required: string;
        }>;
        inputGroupClassName?: string;
        infoText?: string | JSX.Element;
    } & import("../form").FormContextProps & {
        type: string;
        allowMultiple: boolean;
        onChange: any;
    };
    constructor(props: MoneyProps);
    render(): React.JSX.Element;
    private onCurrencyChanged;
    private onTheFlightValidate;
    private onPriceChanged;
    private removePriceClick;
    private addPriceClick;
    private onFocus;
    private onBlur;
}
export declare const Money: React.ForwardRefExoticComponent<MoneyProps & React.RefAttributes<MoneyRaw>>;
export default Money;
