import * as React from 'react';
import { BaseInputProps, BaseInputState, BaseInput } from '../base/input/BaseInput';
export interface NumberInputProps extends BaseInputProps<HTMLInputElement> {
    value?: never;
    onChange?: never;
    onNumberChange: (num: number) => void;
    number: number;
    min?: number;
    max?: number;
    unit?: string;
}
export interface NumberInputState extends BaseInputState {
    currentText: string;
}
export declare class NumberInputRaw extends BaseInput<NumberInputProps, NumberInputState, HTMLInputElement> {
    static defaultProps: Partial<NumberInputProps>;
    constructor(props: NumberInputProps);
    render(): React.JSX.Element;
    private commitState;
    private onBlur;
    private removeUnitClick;
    private onUnitChanged;
    private onKeyDown;
    private addUnitClick;
    private handleLimits;
}
export declare const NumberInput: React.ForwardRefExoticComponent<NumberInputProps & React.RefAttributes<NumberInputRaw>>;
export default NumberInput;
