import * as React from 'react';
import { BaseInputProps, BaseInputState, BaseInput } from '../../base/input/BaseInput';
import { Duration } from 'moment';
export interface OpeningHoursPeriodObj {
    opens: Duration;
    closes: Duration;
    capacity?: number;
}
export interface OpeningHoursDayObj {
    times: OpeningHoursPeriodObj[];
}
export declare const defaultDayTranslations: {
    required: string;
    opens: string;
    closes: string;
    capacity: string;
    add: string;
    midnight: string;
};
export type OpeningHoursDayTranslations = Partial<typeof defaultDayTranslations>;
export interface OpeningHoursDayProps extends BaseInputProps<never, OpeningHoursDayTranslations> {
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onOpeningHoursChange: (openingHours: OpeningHoursDayObj) => void;
    openingHours: OpeningHoursDayObj;
    label?: JSX.Element | string;
    maxOpenCloseTimes?: number;
    useCapacity?: boolean;
}
export interface OpeningHoursState extends BaseInputState {
}
export declare class OpeningHoursDayRaw extends BaseInput<OpeningHoursDayProps, OpeningHoursState, never, OpeningHoursDayTranslations> {
    static defaultProps: {
        theme?: import("../../../types/Theme").Theme;
        id?: string;
        disabled?: boolean;
        className?: string;
        label?: string | JSX.Element;
        tooltip?: string | JSX.Element;
        tooltipProps?: import("@tippy.js/react").TippyProps;
        value?: string;
        onChange?: (e: React.ChangeEvent<never>, isValid: boolean) => void;
        required?: boolean;
        customValidators?: import("../../..").IBaseValidator[];
        validators?: import("../../..").ValidatorTypes[];
        noValidate?: boolean;
        validationName?: string;
        touchOn?: "focus" | "blur";
        ignoreContext?: boolean;
        onTheFlightValidate?: (value: string) => boolean;
        onFocus?: () => void;
        onBlur?: () => void;
        onSuggestionsClosed?: () => void;
        onSuggestionsOpened?: () => void;
        onClick?: (e: React.MouseEvent<Element, MouseEvent>) => void;
        title?: string | JSX.Element;
        onKeyDown?: (e: React.KeyboardEvent<HTMLElement>) => void;
        errors?: import("../../base/input/BaseInput").ValidationError[];
        onErrorsChanged?: (errors: import("../../base/input/BaseInput").ValidationError[]) => void;
        showValidation?: boolean;
        reRendersWhenContextChanges?: boolean;
        defaultTouched?: boolean;
        translations?: Partial<{
            required: string;
        }>;
        inputGroupClassName?: string;
        infoText?: string | JSX.Element;
    } & import("../../form").FormContextProps & {
        onChange: any;
        type: string;
        allowMultiple: boolean;
        maxOpenCloseTimes: number;
    };
    private fullDayMilliseconds;
    constructor(props: OpeningHoursDayProps);
    render(): React.JSX.Element;
    private isAddTimeClickDisabled;
    private addTimeClick;
    private removeTimeClick;
    private timeChanged;
    private getBottomBorder;
    private getTime;
}
export declare const OpeningHoursDay: React.ForwardRefExoticComponent<OpeningHoursDayProps & React.RefAttributes<OpeningHoursDayRaw>>;
export default OpeningHoursDay;
