"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultDayTranslations = exports.default = exports.OpeningHoursDayRaw = exports.OpeningHoursDay = void 0;
var React = _interopRequireWildcard(require("react"));
var _Time = require("../../time/Time");
var _OpeningHoursUtil = _interopRequireDefault(require("../utils/OpeningHoursUtil"));
var _TimeUtil = _interopRequireDefault(require("../../utils/TimeUtil"));
var _InputGroup = _interopRequireDefault(require("../../inputGroup/InputGroup"));
var _BaseInput = require("../../base/input/BaseInput");
var _Button = require("../../button/Button");
var _withFormContext = require("../../form/withFormContext");
var _classnames = _interopRequireDefault(require("classnames"));
var _moment = _interopRequireDefault(require("moment"));
var _NumberInput = _interopRequireDefault(require("../../numberInput/NumberInput"));
var _withThemeContext = require("../../themeProvider/withThemeContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PlusIcon = function PlusIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
  }));
};
PlusIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
}; // Libs
// Misc
const defaultDayTranslations = _objectSpread({
  opens: 'Opens',
  closes: 'Closes',
  capacity: 'Capacity',
  add: 'Add new time range',
  midnight: 'Midnight'
}, _BaseInput.defaultBaseTranslations);
exports.defaultDayTranslations = defaultDayTranslations;
class OpeningHoursDayRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.fullDayMilliseconds = 24 * 60 * 60 * 1000;
    this.addTimeClick = () => {
      let newTime = this.props.openingHours && this.props.openingHours.times && this.props.openingHours.times.length ? this.props.openingHours.times[this.props.openingHours.times.length - 1].closes.clone() : this.getTime(8, 0);
      if (newTime.hours() < 23) {
        newTime = newTime.add(1, 'hour');
      }
      let closeTime = newTime.clone().add(1, 'hour');
      this.props.onOpeningHoursChange(_objectSpread(_objectSpread({}, this.props.openingHours), {}, {
        times: this.props.openingHours.times.concat({
          opens: newTime,
          closes: closeTime,
          capacity: this.props.useCapacity ? 1 : undefined
        })
      }));
    };
    this.removeTimeClick = index => () => this.props.onOpeningHoursChange(_objectSpread(_objectSpread({}, this.props.openingHours), {}, {
      times: this.props.openingHours.times.filter((time, itemIndex) => itemIndex < index || itemIndex > index + 1)
    }));
    this.timeChanged = (index, indexJ) => time => {
      let newOpeningHours = _objectSpread(_objectSpread({}, this.props.openingHours), {}, {
        times: this.props.openingHours.times.slice(0)
      });
      if (indexJ === 0) {
        newOpeningHours.times[index] = _objectSpread(_objectSpread({}, newOpeningHours.times[index]), {}, {
          opens: time
        });
      } else {
        newOpeningHours.times[index] = _objectSpread(_objectSpread({}, newOpeningHours.times[index]), {}, {
          closes: time
        });
      }
      this.props.onOpeningHoursChange(newOpeningHours);
    };
  }
  render() {
    const translations = this.getTranslations(defaultDayTranslations);
    return /*#__PURE__*/React.createElement(_InputGroup.default, {
      title: this.props.title,
      className: (0, _classnames.default)('input__group__openingHoursDay', this.props.className, {
        'input__group__openingHoursDay--closed': this.props.openingHours && this.props.openingHours.times && this.props.openingHours.times.length === 0
      }),
      tooltip: this.props.tooltip
    }, /*#__PURE__*/React.createElement("div", _extends({}, this.props.id && {
      id: this.props.id
    }, {
      className: (0, _classnames.default)('input__base openingHoursDay-input', {
        'openingHoursDay-input--closed': this.props.openingHours && this.props.openingHours.times && this.props.openingHours.times.length === 0
      }, this.getValidationClass()),
      ref: this.containerRef
    }), /*#__PURE__*/React.createElement("div", {
      className: "openingHoursDay-input__container"
    }, this.props.openingHours && this.props.openingHours.times && this.props.openingHours.times.map((item, index) => {
      const times = [item.opens, item.closes];
      return /*#__PURE__*/React.createElement("div", {
        className: "openingHoursDay-input__time__container",
        key: index
      }, times.map((time, indexJ) => {
        const localIndex = index * 2 + indexJ;
        const previousTime = indexJ > 0 ? times[indexJ - 1].clone() : index === 0 ? this.getTime(0, 0) : this.props.openingHours.times[index - 1].closes.clone();
        let nextTime = indexJ === 0 ? times[1] : this.props.openingHours.times.length - 1 > index ? this.props.openingHours.times[index + 1].opens.clone() : this.getTime(23, 59, true);
        if (localIndex % 2 === 0) {
          nextTime = _moment.default.duration(Math.min.apply(null, [this.getTime(23, 59, false).asMilliseconds(), nextTime.asMilliseconds()]), 'millisecond');
        }
        return /*#__PURE__*/React.createElement(_Time.Time, _extends({
          key: `${index}-${indexJ}`
        }, this.props.id && {
          id: `${this.props.id}-time-${index.toString()}-${indexJ.toString()}`
        }, {
          className: 'openingHoursDay-input__time',
          timeChange: this.timeChanged(index, indexJ),
          time: time,
          min: previousTime,
          max: nextTime,
          showDateDiff: true,
          label: indexJ % 2 === 0 ? translations.opens : translations.closes
        }));
      }), this.props.useCapacity && /*#__PURE__*/React.createElement(_NumberInput.default, {
        label: translations.capacity,
        min: 0,
        number: item.capacity,
        onNumberChange: num => this.props.onOpeningHoursChange(_objectSpread(_objectSpread({}, this.props.openingHours), {}, {
          times: this.props.openingHours.times.map((t, i) => i === index ? _objectSpread(_objectSpread({}, t), {}, {
            capacity: num
          }) : t)
        }))
      }), /*#__PURE__*/React.createElement(_Button.Button, _extends({}, this.props.id && {
        id: this.props.id + '-remove-button-' + ((index - 1) / 2).toString()
      }, {
        onClick: this.removeTimeClick(index),
        className: "openingHoursDay-input__button--remove mr-3 line-height--0",
        circular: true,
        blank: true,
        type: "error"
      }), /*#__PURE__*/React.createElement(PlusIcon, null)));
    }), this.props.maxOpenCloseTimes > this.props.openingHours.times.length && /*#__PURE__*/React.createElement(_Button.Button, _extends({}, this.props.id && {
      id: this.props.id + '-add-button'
    }, {
      className: "openingHoursDay-input__button-open-close",
      onClick: this.addTimeClick,
      disabled: this.isAddTimeClickDisabled(),
      type: 'primary',
      hero: true
    }), translations.add)), this.renderDefaultValidation(), this.props.openingHours && this.props.label && /*#__PURE__*/React.createElement("span", {
      className: 'label-classname ' + (this.props.openingHours && this.props.openingHours.times && this.props.openingHours.times.length ? 'label--focused' : 'label--focused label--closed')
    }, this.renderLabel(true))), this.getBottomBorder(translations));
  }
  isAddTimeClickDisabled() {
    if (this.props.openingHours && this.props.openingHours.times && this.props.openingHours.times.length) {
      const dayDiff = _TimeUtil.default.dayDiff(this.props.openingHours.times[0].opens, this.props.openingHours.times[this.props.openingHours.times.length - 1].closes);
      if (dayDiff > 0) {
        return true;
      }
    }
    return false;
  }
  getBottomBorder(translations) {
    const times = (this.props.openingHours && this.props.openingHours.times || []).reduce((a, b) => a.concat([b.opens, b.closes]), []);
    let parts = [];
    let totalTime = this.fullDayMilliseconds;
    if (!times.length) {
      parts = parts.concat([1]);
    } else {
      totalTime = Math.max(this.fullDayMilliseconds, _OpeningHoursUtil.default.getTimeFromMidnight(times[times.length - 1], times[0]));
      parts = parts.concat([_OpeningHoursUtil.default.getTimeFromMidnight(times[0]) / totalTime]);
      for (var index = 0; index < times.length - 1; index++) {
        let start = _OpeningHoursUtil.default.getTimeFromMidnight(times[index], times[0]);
        let end = _OpeningHoursUtil.default.getTimeFromMidnight(times[index + 1], times[0]);
        let diff = (end - start) / totalTime;
        parts = parts.concat([diff]);
      }
      parts = parts.concat([(totalTime - _OpeningHoursUtil.default.getTimeFromMidnight(times[times.length - 1], times[0])) / totalTime]);
    }
    return /*#__PURE__*/React.createElement("div", {
      className: "openingHoursDay-input__bottom-border__container"
    }, parts.map((part, i) => /*#__PURE__*/React.createElement("div", {
      key: i,
      className: 'openingHoursDay-input__bottom-border ' + (i % 2 === 0 ? 'openingHoursDay-input__bottom-border--closed' : 'openingHoursDay-input__bottom-border--open'),
      style: {
        width: part ? (part * 100).toFixed(2) + '%' : '0'
      }
    })), totalTime > this.fullDayMilliseconds && /*#__PURE__*/React.createElement("div", {
      className: "openingHoursDay-input__bottom-border--midnight",
      style: {
        left: (this.fullDayMilliseconds * 100 / totalTime).toString() + '%'
      },
      title: translations.midnight
    }));
  }
  getTime(hours, minutes) {
    let nextDay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    let time = _moment.default.duration(0, 'millisecond').add(hours, 'hours').add(minutes, 'minutes');
    if (nextDay) {
      time = time.add(1, 'day');
    }
    return time;
  }
}
exports.OpeningHoursDayRaw = OpeningHoursDayRaw;
OpeningHoursDayRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  onChange: undefined,
  type: 'openingHours',
  allowMultiple: false,
  maxOpenCloseTimes: 10
});
const OpeningHoursDay = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(OpeningHoursDayRaw), 'openingHoursDay');
exports.OpeningHoursDay = OpeningHoursDay;
var _default = OpeningHoursDay;
exports.default = _default;
//# sourceMappingURL=OpeningHoursDay.js.map