import * as React from 'react';
import { OpeningHoursDayObj } from '../openingHoursDay/OpeningHoursDay';
import { BaseInputProps, BaseInputState, BaseInput } from '../../base/input/BaseInput';
export interface OpeningHoursSpecialDayObj extends OpeningHoursDayObj {
    date?: Date;
    children?: React.ReactNode;
}
export interface OpeningHoursSpecialProps extends BaseInputProps<never, OpeningHoursSpecialTranslations> {
    days: OpeningHoursSpecialDayObj[];
    onDaysChange: (days: OpeningHoursSpecialDayObj[]) => void;
    placeholder?: string;
    useCapacity?: boolean;
}
export interface OpeningHoursSpecialState extends BaseInputState {
}
export declare class DateInput extends React.PureComponent<{
    value?: string;
    onClick?: () => void;
    children?: React.ReactNode;
}> {
    render(): React.JSX.Element;
}
declare const defaultSpecialTranslations: {
    open: string;
    closed: string;
    and: string;
    hour: string;
    hours: string;
    minute: string;
    minutes: string;
    required: string;
    opens: string;
    closes: string;
    capacity: string;
    add: string;
    midnight: string;
    chooseDateError: string;
    chooseDate: string;
};
export type OpeningHoursSpecialTranslations = Partial<typeof defaultSpecialTranslations>;
export declare class OpeningHoursSpecialRaw extends BaseInput<OpeningHoursSpecialProps, OpeningHoursSpecialState, never, OpeningHoursSpecialTranslations> {
    static defaultProps: {
        theme?: import("../../../types/Theme").Theme;
        id?: string;
        disabled?: boolean;
        className?: string;
        label?: string | JSX.Element;
        tooltip?: string | JSX.Element;
        tooltipProps?: import("@tippy.js/react").TippyProps;
        value?: string;
        onChange?: (e: React.ChangeEvent<never>, isValid: boolean) => void;
        required?: boolean;
        customValidators?: import("../../..").IBaseValidator[];
        validators?: import("../../..").ValidatorTypes[];
        noValidate?: boolean;
        validationName?: string;
        touchOn?: "focus" | "blur";
        ignoreContext?: boolean;
        onTheFlightValidate?: (value: string) => boolean;
        onFocus?: () => void;
        onBlur?: () => void;
        onSuggestionsClosed?: () => void;
        onSuggestionsOpened?: () => void;
        onClick?: (e: React.MouseEvent<Element, MouseEvent>) => void;
        title?: string | JSX.Element;
        onKeyDown?: (e: React.KeyboardEvent<HTMLElement>) => void;
        errors?: import("../../base/input/BaseInput").ValidationError[];
        onErrorsChanged?: (errors: import("../../base/input/BaseInput").ValidationError[]) => void;
        showValidation?: boolean;
        reRendersWhenContextChanges?: boolean;
        defaultTouched?: boolean;
        translations?: Partial<{
            required: string;
        }>;
        inputGroupClassName?: string;
        infoText?: string | JSX.Element;
    } & import("../../form").FormContextProps & {
        type: string;
        placeholder: string;
    };
    constructor(props: OpeningHoursSpecialProps);
    componentDidMount(): void;
    componentDidUpdate(oldProps: OpeningHoursSpecialProps): void;
    touch(): void;
    render(): React.JSX.Element;
    private handleDates;
    private removeDayClick;
    private dateChanged;
    private openingHoursChanged;
}
export declare const OpeningHoursSpecial: React.ForwardRefExoticComponent<OpeningHoursSpecialProps & React.RefAttributes<OpeningHoursSpecialRaw>>;
export default OpeningHoursSpecial;
