"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.OpeningHoursSpecialRaw = exports.OpeningHoursSpecial = exports.DateInput = void 0;
var React = _interopRequireWildcard(require("react"));
var _reactDatepicker = _interopRequireDefault(require("react-datepicker"));
var _OpeningHoursUtil = _interopRequireWildcard(require("../utils/OpeningHoursUtil"));
var _OpeningHoursDay = require("../openingHoursDay/OpeningHoursDay");
var _BaseInput = require("../../base/input/BaseInput");
var _Button = require("../../button/Button");
var _withFormContext = require("../../form/withFormContext");
var _withThemeContext = require("../../themeProvider/withThemeContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PlusIcon = function PlusIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
  }));
};
PlusIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
var DateIcon = function DateIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M17 12h-5v5h5v-5zM16 1v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19a2 2 0 0 0 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2h-1V1h-2zm3 18H5V8h14v11z"
  }));
};
DateIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
}; // Libs
/*try {
  var DatePicker = require('react-datepicker').default;
} catch {
  DatePicker = undefined;
}*/
// Misc
const DAY_FORMAT = 'dd/M/yyyy';
class DateInput extends React.PureComponent {
  render() {
    return /*#__PURE__*/React.createElement(_Button.Button, {
      blank: true,
      type: "primary",
      onClick: this.props.onClick
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        display: 'flex'
      }
    }, /*#__PURE__*/React.createElement(DateIcon, {
      style: {
        marginRight: 4
      }
    }), this.props.children ? this.props.children : this.props.value));
  }
}
exports.DateInput = DateInput;
const defaultSpecialTranslations = _objectSpread(_objectSpread(_objectSpread({
  chooseDateError: 'Date not selected',
  chooseDate: 'Choose date'
}, _BaseInput.defaultBaseTranslations), _OpeningHoursDay.defaultDayTranslations), _OpeningHoursUtil.defaultTranslations);
class OpeningHoursSpecialRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.removeDayClick = index => () => this.props.onDaysChange(this.props.days.filter((d, indexInner) => indexInner !== index));
    this.dateChanged = (index, day) => date => {
      let days = this.props.days.slice(0);
      days[index] = _objectSpread(_objectSpread({}, day), {}, {
        date
      });
      this.props.onDaysChange(days);
    };
    this.openingHoursChanged = (index, day) => openingHours => {
      let days = this.props.days.slice(0);
      days[index] = _objectSpread(_objectSpread({}, day), openingHours);
      this.props.onDaysChange(days);
    };
    this.state = _objectSpread(_objectSpread({}, this.state), {
      touched: true
    });
  }
  componentDidMount() {
    if (this.props.days) {
      this.handleDates();
    }
  }
  componentDidUpdate(oldProps) {
    if (this.props.days !== oldProps.days) {
      this.handleDates();
    }
  }
  touch() {
    return;
  }
  render() {
    if (!_reactDatepicker.default) {
      throw new Error('You need to install react-datepicker in order to use special day picker');
    }
    const translations = this.getTranslations(defaultSpecialTranslations);
    return /*#__PURE__*/React.createElement("div", _extends({}, this.props.id && {
      id: this.props.id
    }, {
      className: 'input__base openingHoursSpecial-input ' + this.getValidationClass() + ' ' + (this.props.className ? this.props.className : ''),
      ref: this.containerRef
    }), this.props.days.map((day, index) => /*#__PURE__*/React.createElement(_OpeningHoursDay.OpeningHoursDay, _extends({
      useCapacity: this.props.useCapacity
    }, this.props.id && {
      id: this.props.id + '-opening-hours-day-' + index.toString()
    }, {
      key: index,
      label: /*#__PURE__*/React.createElement("span", null, _OpeningHoursUtil.default.getLabelSuffix(day, this.props.translations), /*#__PURE__*/React.createElement("span", {
        className: "float-right"
      }, /*#__PURE__*/React.createElement(_Button.Button, _extends({}, this.props.id && {
        id: this.props.id + '-remove-button-' + index.toString()
      }, {
        className: "openingHoursDay-input__button--remove line-height--0",
        circular: true,
        blank: true,
        type: "error",
        onClick: this.removeDayClick(index)
      }), /*#__PURE__*/React.createElement(PlusIcon, null)))),
      openingHours: {
        times: day.times
      },
      onOpeningHoursChange: this.openingHoursChanged(index, day),
      title: /*#__PURE__*/React.createElement(_reactDatepicker.default, _extends({}, this.props.id && {
        id: this.props.id + '-date-picker-' + index.toString()
      }, {
        customInput: /*#__PURE__*/React.createElement(DateInput, null, !day.date && translations.chooseDate)
        // placeholder={this.props.placeholder}
        ,
        selected: day.date,
        dateFormat: DAY_FORMAT,
        onChange: this.dateChanged(index, day),
        excludeDates: this.props.days.filter(d => d.date).map(a => a.date),
        withPortal: true,
        minDate: new Date()
      })),
      translations: this.props.translations
    }))), /*#__PURE__*/React.createElement("span", {
      className: "bar"
    }), this.renderDefaultValidation());
  }
  handleDates() {
    const translations = this.getTranslations(defaultSpecialTranslations);
    const allDaysHaveDates = !this.props.days || this.props.days.every(d => Boolean(d.date));
    if (allDaysHaveDates) {
      this.setValid();
    } else {
      this.setInvalid([translations.chooseDateError]);
    }
  }
}
exports.OpeningHoursSpecialRaw = OpeningHoursSpecialRaw;
OpeningHoursSpecialRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  type: 'openingHoursSpecial',
  placeholder: DAY_FORMAT
});
const OpeningHoursSpecial = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(OpeningHoursSpecialRaw), 'openingHoursSpecial');
exports.OpeningHoursSpecial = OpeningHoursSpecial;
var _default = OpeningHoursSpecial;
exports.default = _default;
//# sourceMappingURL=OpeningHoursSpecial.js.map