import * as React from 'react';
import { OpeningHoursDayObj } from '../openingHoursDay/OpeningHoursDay';
import { BaseInputProps, BaseInputState, BaseInput } from '../../base/input/BaseInput';
export declare enum Weekday {
    Monday = 1,
    Tuesday = 2,
    Wednesday = 3,
    Thursday = 4,
    Friday = 5,
    Saturday = 6,
    Sunday = 0
}
export interface OpeningHoursWeekDayObj extends OpeningHoursDayObj {
    isStandardDay?: boolean;
    day: Weekday;
}
export interface OpeningHoursWeekProps extends BaseInputProps<never, OpeningHoursWeekTranslations> {
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    days: OpeningHoursWeekDayObj[];
    onDaysChange: (days: OpeningHoursWeekDayObj[]) => void;
    standardDay?: OpeningHoursDayObj;
    onStandardDayChange?: (day: OpeningHoursDayObj) => void;
    useCapacity?: boolean;
}
export interface OpeningHoursWeekState extends BaseInputState {
}
export declare const defaultWeekTranslations: {
    open: string;
    closed: string;
    and: string;
    hour: string;
    hours: string;
    minute: string;
    minutes: string;
    required: string;
    opens: string;
    closes: string;
    capacity: string;
    add: string;
    midnight: string;
    standardDay: string;
    standardDayTooltip: React.JSX.Element;
    standardDayAll: string;
    standardDayCheckBox: string;
    monday: string;
    tuesday: string;
    wednesday: string;
    thursday: string;
    friday: string;
    saturday: string;
    sunday: string;
};
export type OpeningHoursWeekTranslations = Partial<typeof defaultWeekTranslations>;
export declare class OpeningHoursWeekRaw extends BaseInput<OpeningHoursWeekProps, OpeningHoursWeekState, never, OpeningHoursWeekTranslations> {
    static defaultProps: {
        theme?: import("../../../types/Theme").Theme;
        id?: string;
        disabled?: boolean;
        className?: string;
        label?: string | JSX.Element;
        tooltip?: string | JSX.Element;
        tooltipProps?: import("@tippy.js/react").TippyProps;
        value?: string;
        onChange?: (e: React.ChangeEvent<never>, isValid: boolean) => void;
        required?: boolean;
        customValidators?: import("../../..").IBaseValidator[];
        validators?: import("../../..").ValidatorTypes[];
        noValidate?: boolean;
        validationName?: string;
        touchOn?: "focus" | "blur";
        ignoreContext?: boolean;
        onTheFlightValidate?: (value: string) => boolean;
        onFocus?: () => void;
        onBlur?: () => void;
        onSuggestionsClosed?: () => void;
        onSuggestionsOpened?: () => void;
        onClick?: (e: React.MouseEvent<Element, MouseEvent>) => void;
        title?: string | JSX.Element;
        onKeyDown?: (e: React.KeyboardEvent<HTMLElement>) => void;
        errors?: import("../../base/input/BaseInput").ValidationError[];
        onErrorsChanged?: (errors: import("../../base/input/BaseInput").ValidationError[]) => void;
        showValidation?: boolean;
        reRendersWhenContextChanges?: boolean;
        defaultTouched?: boolean;
        translations?: Partial<{
            required: string;
        }>;
        inputGroupClassName?: string;
        infoText?: string | JSX.Element;
    } & import("../../form").FormContextProps & {
        onChange: any;
        type: string;
        placeholder: string;
        collapsible: boolean;
    };
    constructor(props: OpeningHoursWeekProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    render(): React.JSX.Element;
    private toggleStandardForAll;
    private getInitialState;
    private renderContent;
    private getDayLabel;
    private onOpeningHoursChange;
    private isStandardDayChecked;
    private standardDayChanged;
}
export declare const OpeningHoursWeek: React.ForwardRefExoticComponent<OpeningHoursWeekProps & React.RefAttributes<typeof OpeningHoursWeekRaw>>;
export default OpeningHoursWeek;
