"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultWeekTranslations = exports.default = exports.Weekday = exports.OpeningHoursWeekRaw = exports.OpeningHoursWeek = void 0;
var React = _interopRequireWildcard(require("react"));
var _OpeningHoursUtil = _interopRequireWildcard(require("../utils/OpeningHoursUtil"));
var _OpeningHoursDay = require("../openingHoursDay/OpeningHoursDay");
var _BaseInput = require("../../base/input/BaseInput");
var _Checkbox = require("../../checkbox/Checkbox");
var _withFormContext = require("../../form/withFormContext");
var _withThemeContext = require("../../themeProvider/withThemeContext");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // Libs
// Misc
let Weekday = /*#__PURE__*/function (Weekday) {
  Weekday[Weekday["Monday"] = 1] = "Monday";
  Weekday[Weekday["Tuesday"] = 2] = "Tuesday";
  Weekday[Weekday["Wednesday"] = 3] = "Wednesday";
  Weekday[Weekday["Thursday"] = 4] = "Thursday";
  Weekday[Weekday["Friday"] = 5] = "Friday";
  Weekday[Weekday["Saturday"] = 6] = "Saturday";
  Weekday[Weekday["Sunday"] = 0] = "Sunday";
  return Weekday;
}({});
exports.Weekday = Weekday;
const defaultWeekTranslations = _objectSpread(_objectSpread(_objectSpread({
  standardDay: 'Standard day',
  standardDayTooltip: /*#__PURE__*/React.createElement(React.Fragment, null, "We recommend to use ", /*#__PURE__*/React.createElement("b", null, "Standard day"), " if multiple days share the same opening hours. Check \"Standard day?\" checkbox for each of these days to make them share standard opening hours."),
  standardDayAll: 'Apply to all days?',
  standardDayCheckBox: 'Standard day?',
  monday: 'Monday',
  tuesday: 'Tuesday',
  wednesday: 'Wednesday',
  thursday: 'Thursday',
  friday: 'Friday',
  saturday: 'Saturday',
  sunday: 'Sunday'
}, _BaseInput.defaultBaseTranslations), _OpeningHoursDay.defaultDayTranslations), _OpeningHoursUtil.defaultTranslations);
exports.defaultWeekTranslations = defaultWeekTranslations;
class OpeningHoursWeekRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.onOpeningHoursChange = (index, day) => openingHours => {
      let days = this.props.days.slice(0);
      days[index] = _objectSpread(_objectSpread(_objectSpread({}, day), openingHours), {}, {
        isStandardDay: false
      });
      this.props.onDaysChange(days);
    };
    this.isStandardDayChecked = (index, day) => checked => {
      let days = this.props.days.slice(0);
      days[index] = _objectSpread(_objectSpread({}, day), {}, {
        isStandardDay: checked.target.checked
      });
      this.props.onDaysChange(days);
    };
    this.standardDayChanged = openingHours => {
      this.props.onStandardDayChange(openingHours);
    };
    this.state = _objectSpread({}, this.state);
    this.toggleStandardForAll = this.toggleStandardForAll.bind(this);
  }
  componentDidMount() {
    if (!this.props.days || !this.props.days.length) {
      this.props.onDaysChange(this.getInitialState());
    }
  }
  componentDidUpdate() {
    if (!this.props.days || !this.props.days.length) {
      this.props.onDaysChange(this.getInitialState());
    }
  }
  render() {
    return /*#__PURE__*/React.createElement("div", {
      className: 'openingHoursWeek-input ' + this.getValidationClass() + ' ' + (this.props.className ? this.props.className : ''),
      ref: this.containerRef
    }, this.renderContent());
  }
  toggleStandardForAll() {
    const allDaysStandard = this.props.days.every(d => d.isStandardDay);
    let days = this.props.days.map(d => _objectSpread(_objectSpread({}, d), {}, {
      isStandardDay: !allDaysStandard
    }));
    this.props.onDaysChange(days);
  }
  getInitialState() {
    return [{
      day: Weekday.Monday,
      times: []
    }, {
      day: Weekday.Tuesday,
      times: []
    }, {
      day: Weekday.Wednesday,
      times: []
    }, {
      day: Weekday.Thursday,
      times: []
    }, {
      day: Weekday.Friday,
      times: []
    }, {
      day: Weekday.Saturday,
      times: []
    }, {
      day: Weekday.Sunday,
      times: []
    }];
  }
  renderContent() {
    const allDaysStandard = this.props.days.every(d => d.isStandardDay);
    const weekTranslations = this.getTranslations(defaultWeekTranslations);
    return /*#__PURE__*/React.createElement("div", {
      className: ``
    }, this.props.standardDay && /*#__PURE__*/React.createElement(_OpeningHoursDay.OpeningHoursDay, _extends({
      useCapacity: this.props.useCapacity
    }, this.props.id && {
      id: this.props.id + '-standard-day'
    }, {
      className: "openingHoursWeek__standard-day",
      label: /*#__PURE__*/React.createElement("span", null, _OpeningHoursUtil.default.getLabelSuffix(this.props.standardDay, this.props.translations), /*#__PURE__*/React.createElement("span", {
        className: "float-right openingHoursWeek__is-standard-day"
      }, weekTranslations.standardDayAll, /*#__PURE__*/React.createElement(_Checkbox.Checkbox, {
        className: "label__checkbox",
        checked: allDaysStandard,
        onChecked: this.toggleStandardForAll
      }))),
      openingHours: {
        times: this.props.standardDay.times
      },
      onOpeningHoursChange: this.standardDayChanged,
      title: weekTranslations.standardDay,
      tooltip: weekTranslations.standardDayTooltip,
      translations: this.props.translations
    })), this.props.days.map((day, index) => /*#__PURE__*/React.createElement(_OpeningHoursDay.OpeningHoursDay, _extends({
      useCapacity: this.props.useCapacity
    }, this.props.id && {
      id: this.props.id + '-opening-hours-day-' + index.toString()
    }, {
      className: '',
      key: index,
      label: this.props.standardDay ? /*#__PURE__*/React.createElement("span", null, _OpeningHoursUtil.default.getLabelSuffix(this.props.standardDay && day.isStandardDay ? this.props.standardDay : day, this.props.translations), /*#__PURE__*/React.createElement("span", {
        className: "float-right openingHoursWeek__is-standard-day"
      }, weekTranslations.standardDayCheckBox, /*#__PURE__*/React.createElement(_Checkbox.Checkbox, {
        className: "label__checkbox",
        checked: day.isStandardDay,
        onChecked: this.isStandardDayChecked(index, day)
      }))) : this.getDayLabel(day.day, weekTranslations),
      openingHours: {
        times: this.props.standardDay && day.isStandardDay ? this.props.standardDay.times : day.times
      },
      onOpeningHoursChange: this.onOpeningHoursChange(index, day),
      title: this.getDayLabel(day.day, weekTranslations),
      translations: this.props.translations
    }))), /*#__PURE__*/React.createElement("span", {
      className: "bar"
    }), this.renderDefaultValidation());
  }
  getDayLabel(day, translations) {
    switch (day) {
      case Weekday.Monday:
        return translations.monday;
      case Weekday.Tuesday:
        return translations.tuesday;
      case Weekday.Wednesday:
        return translations.wednesday;
      case Weekday.Thursday:
        return translations.thursday;
      case Weekday.Friday:
        return translations.friday;
      case Weekday.Saturday:
        return translations.saturday;
      case Weekday.Sunday:
        return translations.sunday;
      default:
        return '';
    }
  }
}
exports.OpeningHoursWeekRaw = OpeningHoursWeekRaw;
OpeningHoursWeekRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  onChange: undefined,
  type: 'openingHoursWeek',
  placeholder: '',
  collapsible: false
});
const OpeningHoursWeek = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(OpeningHoursWeekRaw), 'openingHoursWeek');
exports.OpeningHoursWeek = OpeningHoursWeek;
var _default = OpeningHoursWeek;
exports.default = _default;
//# sourceMappingURL=OpeningHoursWeek.js.map