"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultTranslations = exports.default = exports.OpeningHoursUtil = void 0;
var React = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // Libs
const defaultTranslations = {
  open: 'Open',
  closed: 'Closed',
  and: 'and',
  hour: 'hour',
  hours: 'hours',
  minute: 'minute',
  minutes: 'minutes'
};
exports.defaultTranslations = defaultTranslations;
class OpeningHoursUtil {
  getTimeFromMidnight(time) {
    let midnight = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : time;
    midnight = midnight.clone().subtract(midnight.hours(), 'hours').subtract(midnight.minutes(), 'minutes').subtract(midnight.seconds(), 'seconds').subtract(midnight.milliseconds(), 'milliseconds');
    const diff = time.asMilliseconds() - midnight.asMilliseconds();
    return diff;
  }
  getTotalTimeString(times, translations) {
    translations = this.getTranslations(translations);
    let totalTime = 0;
    let newTimes = times.slice(0).map(item => this.getTimeFromMidnight(item, times[0]));
    if (times.length % 2 === 1) {
      newTimes = newTimes.concat([86400000 + 60 * 1000]);
    }
    for (let index = 0; index < newTimes.length - 1; index++) {
      if (index % 2 === 0) {
        let time = newTimes[index];
        let nextTime = newTimes[index + 1];
        totalTime += nextTime - time;
      }
    }
    const hours = Math.floor(totalTime / 3600000);
    const minutes = Math.floor(totalTime / (60 * 1000)) % 60;
    const hoursFormatted = hours ? hours.toFixed(0) + ' ' + (hours > 1 ? translations.hours : translations.hour) : '';
    const minutesFormatted = minutes ? minutes.toFixed(0) + ' ' + (minutes > 1 ? translations.minutes : translations.minute) : '';
    if (hoursFormatted && minutesFormatted) {
      return /*#__PURE__*/React.createElement("span", null, translations.open, " ", hoursFormatted, " ", translations.and, ' ', minutesFormatted);
    }
    if (hoursFormatted) {
      return /*#__PURE__*/React.createElement("span", null, translations.open, " ", hoursFormatted);
    }
    if (minutesFormatted) {
      return /*#__PURE__*/React.createElement("span", null, translations.open, " ", minutesFormatted);
    }
    return /*#__PURE__*/React.createElement("span", null, translations.closed);
  }
  getLabelSuffix(day, translations) {
    translations = this.getTranslations(translations);
    return day && day.times && day.times.length === 0 ? translations.closed : this.getTotalTimeString((day.times || []).reduce((a, b) => a.concat([b.opens, b.closes]), []), translations);
  }
  getTranslations(translations) {
    return _objectSpread(_objectSpread({}, defaultTranslations), translations);
  }
}
exports.OpeningHoursUtil = OpeningHoursUtil;
const util = new OpeningHoursUtil();
var _default = util;
exports.default = _default;
//# sourceMappingURL=OpeningHoursUtil.js.map