"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.RadioRaw = exports.Radio = void 0;
var React = _interopRequireWildcard(require("react"));
var _BaseInput = require("../base/input/BaseInput");
var _withFormContext = require("../form/withFormContext");
var _withThemeContext = require("../themeProvider/withThemeContext");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // Libs
// Misc

class RadioRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.onChecked = this.onChecked.bind(this);
  }
  render() {
    return /*#__PURE__*/React.createElement("div", {
      className: `radio-input ${this.getValidationClass()} ${this.props.className ? this.props.className : ''}`,
      ref: this.containerRef
    }, !this.props.label && this.renderInput(), this.props.label && /*#__PURE__*/React.createElement("label", null, this.renderInput(), this.props.label));
  }
  renderInput() {
    return /*#__PURE__*/React.createElement("input", _extends({}, this.props.id && {
      id: this.props.id
    }, {
      disabled: this.getDisabled(),
      name: this.props.name,
      value: this.props.value,
      type: "radio",
      required: this.props.required,
      checked: this.props.value === this.props.result,
      onChange: this.onChecked,
      onBlur: this.handleBlur,
      onFocus: this.handleFocus,
      tabIndex: 0
    }));
  }
  onChecked(e) {
    // e.preventDefault();
    this.props.onChecked && this.props.onChecked(e.target.value);
  }
}
exports.RadioRaw = RadioRaw;
RadioRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  onChange: undefined
});
const Radio = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(RadioRaw), 'radio');
exports.Radio = Radio;
var _default = Radio;
exports.default = _default;
//# sourceMappingURL=Radio.js.map