"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SelectRaw = exports.Select = void 0;
var React = _interopRequireWildcard(require("react"));
var _InputGroup = _interopRequireDefault(require("../inputGroup/InputGroup"));
var _BaseInput = require("../base/input/BaseInput");
var _Button = require("../button/Button");
var _withFormContext = require("../form/withFormContext");
var _withThemeContext = require("../themeProvider/withThemeContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // Libs
// Misc
var PlusIcon = function PlusIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
  }));
};
PlusIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
class SelectRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.removeItemClick = item => () => {
      const newValues = this.props.selectedValues.filter(sv => sv.value !== item.value);
      this.handleValid(newValues);
      this.props.onSelectedValuesChange && this.props.onSelectedValuesChange(newValues);
    };
    const val = !props.value ? props.defaultEmpty ? '' : props.values && props.values.length > 0 ? props.values[0] : '' : props.value;
    this.state = Object.assign(this.state, {
      value: val
    });
    this.handleChangeCustom = this.handleChangeCustom.bind(this);
  }
  componentDidMount() {
    this.props.multiple && this.handleValid(this.props.selectedValues);
  }
  componentDidUpdate(oldProps) {
    if (oldProps.value !== this.props.value || oldProps.validators !== this.props.validators || oldProps.customValidators !== this.props.customValidators || oldProps.required !== this.props.required || oldProps.selectedValues !== this.props.selectedValues) {
      if (this.props.multiple) {
        this.handleValid(this.props.selectedValues);
      } else {
        this.handleValueChange(this.props.value, true, [], this.props);
      }
    }
  }
  render() {
    const finalValues = this.props.multiple ? this.props.values.filter(item => this.props.selectedValues.findIndex(t => t.value === item.value) < 0) : this.props.values;
    return /*#__PURE__*/React.createElement(_InputGroup.default, {
      title: this.props.title,
      tooltip: this.props.tooltip,
      className: this.props.inputGroupClassName
    }, /*#__PURE__*/React.createElement("div", {
      className: 'input__base select-input ' + this.getValidationClass() + ' ' + (this.props.className ? this.props.className : '') + ' ' + (this.props.readOnly ? 'readonly' : '') + ' ' + (this.props.multiple ? 'multiple' : ''),
      ref: this.containerRef
    }, this.renderSelectedValues(), finalValues.length > 0 && (this.props.multiple && !this.props.readOnly || !this.props.multiple) && /*#__PURE__*/React.createElement("div", {
      className: "select-input__select__wrapper"
    }, !this.props.multiple && !this.props.readOnly || this.props.multiple ? /*#__PURE__*/React.createElement("select", _extends({}, this.props.id && {
      id: this.props.id
    }, {
      ref: this.inputRef,
      disabled: this.getDisabled(),
      required: this.props.required,
      onChange: this.handleChangeCustom,
      value: this.state.value,
      className: 'select-input__select ' + (this.state.value !== '' || this.props.selectedValues && this.props.selectedValues.length > 0 ? 'filled' : ''),
      onBlur: this.handleBlur,
      onFocus: this.handleFocus,
      tabIndex: 0
    }), this.props.defaultEmpty && /*#__PURE__*/React.createElement("option", {
      key: -1,
      disabled: true,
      value: "",
      style: {
        display: 'none'
      }
    }), finalValues.map((value, index) => /*#__PURE__*/React.createElement("option", {
      key: index,
      value: value.value
    }, value.label ? value.label : value.value))) : /*#__PURE__*/React.createElement("span", {
      className: 'select-input__select ' + (this.state.value !== '' || this.props.selectedValues && this.props.selectedValues.length > 0 ? 'filled' : '')
    }, this.renderReadonly()), /*#__PURE__*/React.createElement("span", {
      className: "highlight"
    }), /*#__PURE__*/React.createElement("span", {
      className: "bar"
    }), this.renderDefaultValidation(), this.props.label && finalValues.length > 0 && /*#__PURE__*/React.createElement("label", null, this.renderLabel()))));
  }
  handleValueChange(value) {
    let isValid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    let errors = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    let props = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : this.props;
    let initializing = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
    if (!this.props.multiple) {
      return super.handleValueChange(value, isValid, errors, props, initializing);
    } else if (!initializing) {
      this.handleValid(this.props.selectedValues);
    }
    return {
      isValid: true,
      errors: []
    };
  }
  handleBlur() {
    this.props.onBlur && this.props.onBlur();
    let state = {
      focused: false
    };
    if (!this.state.touched && this.props.touchOn === 'blur') {
      state = Object.assign(state, {
        touched: true
      });
      if (!this.props.multiple) {
        this.handleValueChange(this.state.value);
      } else {
        this.handleValid(this.props.selectedValues);
      }
    }
    this.setState(state);
  }
  handleFocus() {
    var _this$props$onFocus, _this$props;
    (_this$props$onFocus = (_this$props = this.props).onFocus) === null || _this$props$onFocus === void 0 ? void 0 : _this$props$onFocus.call(_this$props);
    let state = {
      focused: true
    };
    if (!this.state.touched && this.props.touchOn === 'focus') {
      state = Object.assign(state, {
        touched: true
      });
      if (!this.props.multiple) {
        this.handleValueChange(this.state.value);
      } else {
        this.handleValid(this.props.selectedValues);
      }
    }
    this.setState(state);
  }
  handleChangeCustom(event) {
    if (this.props.multiple) {
      let value = event.target.value;
      let val = this.props.values.filter(item => item.value === value)[0];
      if (!val) {
        if (!isNaN(Number(value))) {
          let valNumber = Number(value);
          val = this.props.values.filter(item => item.value === valNumber)[0];
        }
      }
      let newValues = this.props.selectedValues.concat(val);
      if (val) {
        this.props.onSelectedValuesChange && this.props.onSelectedValuesChange(newValues);
        this.handleValid(newValues);
        this.setState({
          value: ''
        });
      }
    } else {
      this.handleChange(event);
    }
  }
  handleValid(newValues) {
    let isValid = true;
    let errors = [];
    if (this.props.required) {
      if (newValues.length === 0) {
        isValid = false;
        errors.push(this.getTranslations(_BaseInput.defaultBaseTranslations).required);
      }
    }
    if (this.props.customValidators) {
      this.props.customValidators.forEach(customValidator => {
        var _this$state;
        let validInner = false;
        validInner = customValidator.Validate((_this$state = this.state) === null || _this$state === void 0 ? void 0 : _this$state.value, this.props.required, error => errors.push(error));
        if (isValid && !validInner) {
          isValid = validInner;
        }
      });
    }
    if (isValid) {
      this.setValid();
    } else {
      this.setInvalid(errors);
    }
  }
  renderReadonly() {
    const value = this.props.values.filter(item => item.value.toString() === this.state.value)[0];
    return value ? value.label ? value.label : value.value : '';
  }
  renderSelectedValues() {
    return this.props.multiple ? this.props.selectedValues.length > 0 ? /*#__PURE__*/React.createElement("div", {
      className: "select-input__selectedValue__wrapper"
    }, this.props.selectedValues.map((item, index) => /*#__PURE__*/React.createElement("div", {
      className: "select-input__selectedValue",
      key: index
    }, item.label ? item.label : item.value, !this.props.readOnly && /*#__PURE__*/React.createElement(_Button.Button, {
      disabled: item.forceSelected,
      circular: true,
      blank: true,
      onClick: this.removeItemClick(item),
      className: "ml-1 transform-rotate--45 line-height--0 p-0"
    }, /*#__PURE__*/React.createElement(PlusIcon, null))))) : this.props.readOnly && /*#__PURE__*/React.createElement("div", {
      className: "select-input__selectedValue__wrapper"
    }, /*#__PURE__*/React.createElement("div", {
      className: "select-input__selectedValue"
    }, this.props.readonlyEmptyPlaceholder)) : null;
  }
}
exports.SelectRaw = SelectRaw;
SelectRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  defaultEmpty: true,
  multiple: false,
  readOnly: false,
  readonlyEmptyPlaceholder: 'N/A'
});
const Select = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(SelectRaw), 'select');
exports.Select = Select;
var _default = Select;
exports.default = _default;
//# sourceMappingURL=Select.js.map