"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultSubmitTranslations = exports.default = exports.SubmitRaw = exports.Submit = void 0;
var React = _interopRequireWildcard(require("react"));
var _BaseInput = require("../base/input/BaseInput");
var _Button = require("../button/Button");
var _withFormContext = require("../form/withFormContext");
var _FormValidationSummary = require("./../form/FormValidationSummary");
var _SubmitValidationSummary = _interopRequireDefault(require("./subComponents/SubmitValidationSummary"));
var _withThemeContext = require("../themeProvider/withThemeContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // Libs
// Misc
const defaultSubmitTranslations = _objectSpread(_objectSpread({}, _BaseInput.defaultBaseTranslations), {}, {
  hangOn: 'Hang on',
  needsFixing: '... needs fixing'
});
exports.defaultSubmitTranslations = defaultSubmitTranslations;
class SubmitRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
  }
  render() {
    const disabled = this.isDisabled();
    const translations = this.getTranslations(defaultSubmitTranslations);
    return /*#__PURE__*/React.createElement(_Button.Button, _extends({}, this.props, {
      className: `${this.props.className ? this.props.className : ''}`,
      onClick: this.handleClick,
      disabled: disabled,
      buttonProps: _objectSpread(_objectSpread({}, this.props.buttonProps), {}, {
        type: 'submit',
        title: disabled ? this.props.disabledTitle : this.props.buttonProps && this.props.buttonProps.title
      }),
      tooltip: this.props.tooltip ? this.props.tooltip : this.props.showValidationSummaryTooltip && !this.props.formContext.isFormValid && /*#__PURE__*/React.createElement(_FormValidationSummary.FormValidationSummaryRaw, {
        title: translations.hangOn,
        footer: translations.needsFixing,
        containerClassName: "",
        headerClassName: "submitValidationSummary__header",
        footerClassName: "submitValidationSummary__footer",
        Component: _SubmitValidationSummary.default,
        formContext: this.props.formContext
      }),
      tooltipProps: _objectSpread({
        theme: 'validation'
      }, this.props.tooltipProps)
    }), this.props.children);
  }
  handleClick(e) {
    if (this.props.preventsDefault) {
      e.preventDefault();
    }
    this.props.onClick && this.props.onClick(e);
  }
  isDisabled() {
    const disabled = this.getDisabled();
    return disabled ? disabled : this.props.validateForm && this.props.formContext ? !this.props.formContext.isFormValid : false;
  }
}
exports.SubmitRaw = SubmitRaw;
SubmitRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  validateForm: true,
  ignoreContext: true,
  reRendersWhenContextChanges: true,
  showValidationSummaryTooltip: true,
  preventsDefault: true
});
const Submit = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(SubmitRaw), 'submit');
exports.Submit = Submit;
var _default = Submit;
exports.default = _default;
//# sourceMappingURL=Submit.js.map