import * as React from 'react';
import { ResourceTConstraint, Tag } from '..';
import { PopperProps } from '@mui/material/Popper';
export type RenderSuggestionTagProps<IdT extends number | string = number, T extends ResourceTConstraint<IdT> = Tag<IdT>> = {
    tag: T;
    index: number;
    id?: string;
    onClick: (e: React.MouseEvent<HTMLElement>) => void;
    isPreselected: boolean;
    getName: (tag: T) => string;
};
export type SuggestionsProps<IdT extends number | string = number, T extends ResourceTConstraint<IdT> = Tag<IdT>> = {
    className?: string;
    innerRef: React.RefObject<HTMLDivElement>;
    anchorEl: HTMLElement;
    id?: string;
    preselectedSuggestion?: number;
    isVisible: boolean;
    isWaitingForMoreInput: boolean;
    tags: T[];
    onSelected: (tag: T, lastSelected: boolean) => void;
    value: string;
    loading: boolean;
    LoadingComponent?: string | JSX.Element;
    EmptyComponent?: string | JSX.Element;
    EmptyAllowNewComponent?: string | JSX.Element;
    AddNewTagComponent?: JSX.Element;
    WaitingForMoreInputComponent?: string | JSX.Element;
    allowNew: boolean;
    popperProps?: Partial<PopperProps>;
    SuggestionTag?: React.ComponentType<RenderSuggestionTagProps<IdT, T>>;
    getName: (tag: T) => string;
};
type InjectedProps = {};
declare function Suggestions<IdT extends number | string = number, T extends ResourceTConstraint<IdT> = Tag<IdT>>(props: SuggestionsProps<IdT, T> & InjectedProps): React.JSX.Element;
declare const SuggestionsWrapped: typeof Suggestions;
export default SuggestionsWrapped;
