"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var React = _interopRequireWildcard(require("react"));
var _button = require("../../button");
var _Popper = _interopRequireDefault(require("@mui/material/Popper"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const popperModifiers = [{
  name: 'flip',
  enabled: true
}];
function DefaultSuggestionTag(_ref) {
  let {
    index,
    tag,
    id,
    onClick,
    isPreselected,
    getName
  } = _ref;
  return /*#__PURE__*/React.createElement("li", {
    key: index
  }, /*#__PURE__*/React.createElement(_button.Button, _extends({}, id && {
    id: id + '-suggestion-' + index.toString()
  }, {
    className: 'w-100 tags-input__suggestion ' + (isPreselected ? 'tags-input__suggestion--preselected' : ''),
    onClick: onClick,
    dropdown: true
  }), getName(tag)));
}
function Suggestions(props) {
  var _props$anchorEl2;
  const {
    onSelected
  } = props;
  const onSelectedFactory = React.useCallback((tag, lastSelected) => e => {
    onSelected(tag, lastSelected);
  }, [onSelected]);
  const popperStyle = React.useMemo(() => {
    var _props$anchorEl;
    return {
      width: (_props$anchorEl = props.anchorEl) === null || _props$anchorEl === void 0 ? void 0 : _props$anchorEl.scrollWidth,
      zIndex: 10000
    };
  }, [(_props$anchorEl2 = props.anchorEl) === null || _props$anchorEl2 === void 0 ? void 0 : _props$anchorEl2.scrollWidth]);
  const {
    SuggestionTag = DefaultSuggestionTag
  } = props;
  return props.anchorEl && /*#__PURE__*/React.createElement(_Popper.default, _extends({
    open: props.isVisible,
    anchorEl: props.anchorEl,
    style: popperStyle,
    placement: "bottom-start",
    modifiers: popperModifiers
  }, props.popperProps), /*#__PURE__*/React.createElement("div", _extends({}, props.id && {
    id: props.id
  }, {
    className: (0, _classnames.default)('tags-input__suggestions', props.className, {
      'tags-input__suggestions--loading': props.loading
    }),
    ref: props.innerRef
  }), /*#__PURE__*/React.createElement("ul", null, props.AddNewTagComponent, props.loading && props.LoadingComponent, props.isWaitingForMoreInput && props.WaitingForMoreInputComponent && /*#__PURE__*/React.createElement("li", {
    className: "w-100 text-center p-2"
  }, props.WaitingForMoreInputComponent), !props.isWaitingForMoreInput && props.tags.map((tag, index) => /*#__PURE__*/React.createElement(SuggestionTag, {
    key: tag.id,
    index: index,
    tag: tag,
    onClick: onSelectedFactory(tag, props.tags.length === 1),
    id: props.id,
    isPreselected: props.preselectedSuggestion !== undefined && props.preselectedSuggestion === index,
    getName: props.getName
  })), props.EmptyComponent && props.tags.length === 0 && !props.allowNew && !props.isWaitingForMoreInput && !props.loading && /*#__PURE__*/React.createElement("li", {
    className: "w-100 text-center p-2"
  }, props.EmptyComponent), props.EmptyAllowNewComponent && props.tags.length === 0 && props.value.length === 0 && props.allowNew && !props.loading && /*#__PURE__*/React.createElement("li", {
    className: "w-100 text-center p-2"
  }, props.EmptyAllowNewComponent))));
}
const SuggestionsWrapped = Suggestions;
var _default = SuggestionsWrapped;
exports.default = _default;
//# sourceMappingURL=TagsSuggestions.js.map