import * as React from 'react';
import { BaseInputProps, BaseInputState, BaseInput } from '../base/input/BaseInput';
export interface TextProps extends BaseInputProps<HTMLInputElement> {
    mask?: string;
    reverse?: boolean;
    placeholder?: string;
    stopClickPropagation?: boolean;
    inputRef?: React.Ref<HTMLInputElement>;
    readOnly?: boolean;
    type?: 'number' | 'text';
    maxLength?: number;
    showClearButton?: boolean;
    after?: React.ReactNode;
    before?: React.ReactNode;
    sizeFromValue?: boolean;
    onNumberChange?: (number: number, isValid: boolean) => void;
    number?: number;
}
export interface TextState extends BaseInputState {
}
export declare class TextRaw extends BaseInput<TextProps, TextState, HTMLInputElement> {
    static defaultProps: TextProps;
    constructor(props: TextProps);
    componentDidUpdate(prevProps: TextProps, prevState: TextState): void;
    render(): React.JSX.Element;
    private clearClick;
    private containerClick;
    private onKeyDown;
}
export declare const Text: React.ForwardRefExoticComponent<TextProps & React.RefAttributes<TextRaw>>;
export default Text;
