"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TextRaw = exports.Text = void 0;
var React = _interopRequireWildcard(require("react"));
var _InputGroup = _interopRequireDefault(require("../inputGroup/InputGroup"));
var _BaseInput = require("../base/input/BaseInput");
var _withFormContext = require("../form/withFormContext");
var _withThemeContext = require("../themeProvider/withThemeContext");
var _button = _interopRequireDefault(require("../button"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // Libs
// Misc
var PlusIcon = function PlusIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z"
  }));
};
PlusIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
};
class TextRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.clearClick = () => {
      if (this.inputRef.current) {
        var nativeTextAreaValueSetter = Object.getOwnPropertyDescriptor(window.HTMLInputElement.prototype, 'value').set;
        if (nativeTextAreaValueSetter) {
          nativeTextAreaValueSetter.call(this.inputRef.current, '');
          const event = new Event('input', {
            bubbles: true
          });
          this.inputRef.current.dispatchEvent(event);
        }
      }
    };
    this.containerClick = e => this.props.stopClickPropagation && e.stopPropagation();
    this.onKeyDown = e => this.props.onKeyDown && this.props.onKeyDown(e);
    if (props.number !== undefined || props.onNumberChange) {
      var _props$number;
      const value = ((_props$number = props.number) === null || _props$number === void 0 ? void 0 : _props$number.toString()) ?? '';
      const res = this.handleValueChange(value, true, [], props, true);
      this.state = _objectSpread(_objectSpread({}, this.state), {}, {
        isValid: res.isValid,
        errors: res.errors,
        value
      });
      if (!this.props.ignoreContext) {
        this.props.formContext && this.props.formContext.updateCallback(this.componentId, {
          validation: {
            isValid: res.isValid,
            errors: res.errors
          }
        });
      }
    }
  }
  componentDidUpdate(prevProps, prevState) {
    if (this.props.onNumberChange && (this.state.isValid !== prevState.isValid || this.state.value !== prevState.value) && this.props.number !== Number(this.state.value)) {
      const num = Number(this.state.value);
      if (this.state.value === '') {
        this.props.onNumberChange(undefined, this.state.isValid);
      } else if (!isNaN(num)) {
        this.props.onNumberChange(num, this.state.isValid);
      }
    }
    if ((prevProps.number !== undefined || this.props.number !== undefined) && this.props.number !== prevProps.number) {
      var _this$props$number;
      this.handleValueChange(((_this$props$number = this.props.number) === null || _this$props$number === void 0 ? void 0 : _this$props$number.toString()) ?? '');
    }
    if (!this.props.onNumberChange && (prevProps.value !== this.props.value || prevProps.validators !== this.props.validators || prevProps.customValidators !== this.props.customValidators || prevProps.required !== this.props.required)) {
      this.handleValueChange(this.props.value, true, [], this.props);
    }
  }
  render() {
    var _this$state$value, _this$props$value;
    const clearButtonHidden = !((_this$state$value = this.state.value) !== null && _this$state$value !== void 0 && _this$state$value.length) || this.props.disabled;
    return /*#__PURE__*/React.createElement(_InputGroup.default, {
      title: this.props.title,
      tooltip: this.props.tooltip,
      className: this.props.inputGroupClassName
    }, /*#__PURE__*/React.createElement("div", {
      className: `input__base text-input ${this.getValidationClass()} 
                    ${this.props.readOnly ? 'text-input--readOnly' : ''} ${this.props.className ? this.props.className : ''}`,
      onClick: this.containerClick,
      ref: this.containerRef
    }, /*#__PURE__*/React.createElement("div", {
      className: "text-input__textWrapper"
    }, this.props.before, /*#__PURE__*/React.createElement("input", _extends({}, this.props.id && {
      id: this.props.id
    }, {
      ref: this.inputRef,
      placeholder: this.props.placeholder,
      disabled: this.getDisabled(),
      required: this.props.required,
      className: this.state.value ? 'filled' : '',
      onChange: this.handleChange,
      value: this.state.value ?? '',
      onBlur: this.handleBlur,
      onFocus: this.handleFocus,
      readOnly: this.props.readOnly,
      onKeyDown: this.onKeyDown,
      type: this.props.type,
      onClick: this.props.onClick,
      maxLength: this.props.maxLength,
      size: this.props.sizeFromValue ? ((_this$props$value = this.props.value) === null || _this$props$value === void 0 ? void 0 : _this$props$value.length) || 1 : undefined
    })), this.props.after, !this.props.readOnly && this.props.showClearButton && /*#__PURE__*/React.createElement(_button.default, _extends({}, this.props.id && {
      id: this.props.id + '-clear-button'
    }, {
      disabled: clearButtonHidden,
      unobtrusive: true,
      noShadow: true,
      onClick: this.clearClick,
      className: (0, _classnames.default)('text-input__clearButton line-height--0', {
        'text-input__clearButton--hidden': clearButtonHidden
      })
    }), /*#__PURE__*/React.createElement(PlusIcon, {
      className: "transform-rotate--45 line-height--0"
    })), /*#__PURE__*/React.createElement("span", {
      className: "highlight"
    }), /*#__PURE__*/React.createElement("span", {
      className: "bar"
    }), this.renderDefaultValidation(), this.props.label && /*#__PURE__*/React.createElement("label", {
      className: this.props.readOnly ? 'label--focused' : ''
    }, this.renderLabel()))));
  }
}
exports.TextRaw = TextRaw;
TextRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  type: 'text',
  stopClickPropagation: true,
  readOnly: false
});
const Text = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(TextRaw), 'text');
exports.Text = Text;
var _default = Text;
exports.default = _default;
//# sourceMappingURL=Text.js.map