import * as React from 'react';
import { BaseInputProps, BaseInputState, BaseInput } from '../base/input/BaseInput';
export interface TextAreaProps extends BaseInputProps<HTMLTextAreaElement> {
    mask?: string;
    reverse?: boolean;
    placeholder?: string;
    stopClickPropagation?: boolean;
    inputRef?: (input: HTMLTextAreaElement) => void;
    readOnly?: boolean;
    type?: 'number' | 'text';
    minRows?: number;
    maxRows?: number;
    maxLength?: number;
}
export interface TextAreaState extends BaseInputState {
}
export declare class TextAreaRaw extends BaseInput<TextAreaProps, TextAreaState, HTMLTextAreaElement> {
    static defaultProps: TextAreaProps;
    private elem;
    constructor(props: TextAreaProps);
    render(): React.JSX.Element;
    focus(): void;
    private onKeyDown;
    private elemRef;
    private onContainerClick;
}
export declare const TextArea: React.ForwardRefExoticComponent<TextAreaProps & React.RefAttributes<TextAreaRaw>>;
export default TextArea;
