"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TextAreaRaw = exports.TextArea = void 0;
var React = _interopRequireWildcard(require("react"));
var _InputGroup = _interopRequireDefault(require("../inputGroup/InputGroup"));
var _BaseInput = require("../base/input/BaseInput");
var _withFormContext = require("../form/withFormContext");
var _TextareaAutosize = _interopRequireDefault(require("@mui/material/TextareaAutosize"));
var _withThemeContext = require("../themeProvider/withThemeContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // Libs
// Misc
class TextAreaRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.elem = void 0;
    this.onKeyDown = e => this.props.onKeyDown && this.props.onKeyDown(e);
    this.elemRef = elem => {
      this.elem = elem;
      this.props.inputRef && this.props.inputRef(elem);
    };
    this.onContainerClick = e => this.props.stopClickPropagation && e.stopPropagation();
  }
  render() {
    return /*#__PURE__*/React.createElement(_InputGroup.default, {
      title: this.props.title,
      className: this.props.inputGroupClassName,
      tooltip: this.props.tooltip
    }, /*#__PURE__*/React.createElement("div", {
      className: `input__base textArea-input ${this.getValidationClass()} 
                    ${this.props.readOnly ? 'textArea-input--readOnly' : ''} 
                    ${this.props.className ? this.props.className : ''}`,
      onClick: this.onContainerClick,
      ref: this.containerRef
    }, /*#__PURE__*/React.createElement(_TextareaAutosize.default, _extends({}, this.props.id && {
      id: this.props.id
    }, {
      ref: this.elemRef,
      placeholder: this.props.placeholder,
      disabled: this.getDisabled(),
      required: this.props.required,
      className: this.state.value ? 'filled' : '',
      onChange: this.handleChange,
      value: this.state.value,
      onBlur: this.handleBlur,
      onFocus: this.handleFocus,
      readOnly: this.props.readOnly,
      onKeyDown: this.onKeyDown,
      minRows: this.props.minRows,
      maxRows: this.props.maxRows,
      maxLength: this.props.maxLength
    })), /*#__PURE__*/React.createElement("span", {
      className: "highlight"
    }), /*#__PURE__*/React.createElement("span", {
      className: "bar"
    }), this.renderDefaultValidation(), this.props.label && /*#__PURE__*/React.createElement("label", null, this.renderLabel())));
  }
  focus() {
    this.elem && this.elem.focus();
  }
}
exports.TextAreaRaw = TextAreaRaw;
TextAreaRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  type: 'text',
  placeholder: '',
  stopClickPropagation: true,
  readOnly: false
});
const TextArea = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(TextAreaRaw), 'textArea');
exports.TextArea = TextArea;
var _default = TextArea;
exports.default = _default;
//# sourceMappingURL=TextArea.js.map