"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withThemeContext = withThemeContext;
var React = _interopRequireWildcard(require("react"));
var _ThemeContext = require("./ThemeContext");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const getOverrideProps = (theme, key) => {
  var _theme$overrides, _theme$overrides$key;
  return key && (theme === null || theme === void 0 ? void 0 : (_theme$overrides = theme.overrides) === null || _theme$overrides === void 0 ? void 0 : (_theme$overrides$key = _theme$overrides[key]) === null || _theme$overrides$key === void 0 ? void 0 : _theme$overrides$key.props);
};
function withThemeContext(Component, componentName) {
  const WithThemeContext = /*#__PURE__*/React.forwardRef((props, ref) => {
    return /*#__PURE__*/React.createElement(_ThemeContext.ThemeContextConsumer, null, value => /*#__PURE__*/React.createElement(Component, _extends({
      ref: ref
    }, getOverrideProps(value, componentName), props, {
      theme: value
    })));
  });
  return WithThemeContext;
}
//# sourceMappingURL=withThemeContext.js.map