import * as React from 'react';
import { BaseInputProps, BaseInputState, BaseInput } from '../base/input/BaseInput';
import { Duration } from 'moment';
export interface TimeProps extends BaseInputProps<HTMLInputElement> {
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    timeChange: (time: Duration) => void;
    time: Duration;
    min?: Duration;
    max?: Duration;
    showDateDiff?: boolean;
}
export interface TimeState extends BaseInputState {
    hoursText?: string;
    minutesText?: string;
}
export declare class TimeRaw extends BaseInput<TimeProps, TimeState, HTMLInputElement> {
    static defaultProps: TimeProps;
    constructor(props: TimeProps);
    render(): React.JSX.Element;
    private onBlur;
    private onMinutesChanged;
    private removeMinuteClick;
    private addMinuteClick;
    private removeHourClick;
    private onHoursChanged;
    private addHourClick;
    private handleLimits;
    private handleHoursChange;
    private handleMinutesChange;
}
export declare const Time: React.ForwardRefExoticComponent<TimeProps & React.RefAttributes<TimeRaw>>;
export default Time;
