"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TimeRaw = exports.Time = void 0;
var React = _interopRequireWildcard(require("react"));
var _InputGroup = _interopRequireDefault(require("../inputGroup/InputGroup"));
var _BaseInput = require("../base/input/BaseInput");
var _withFormContext = require("../form/withFormContext");
var _TimeUtil = _interopRequireDefault(require("../utils/TimeUtil"));
var _moment = _interopRequireDefault(require("moment"));
var _withThemeContext = require("../themeProvider/withThemeContext");
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var ArrowIcon = function ArrowIcon(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z"
  }));
};
ArrowIcon.defaultProps = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24"
}; // Libs
// Misc
class TimeRaw extends _BaseInput.BaseInput {
  constructor(props) {
    super(props);
    this.onBlur = () => {
      if (this.state.hoursText) {
        this.handleHoursChange(this.state.hoursText);
      }
      if (this.state.minutesText) {
        this.handleMinutesChange(this.state.minutesText);
      }
      this.setState({
        minutesText: undefined,
        hoursText: undefined
      }, () => this.handleBlur());
    };
    this.onMinutesChanged = e => {
      // this.handleMinutesChange(e.target.value);
      this.setState({
        minutesText: e.target.value
      });
    };
    this.removeMinuteClick = e => {
      var _this$props$time, _this$props$time$minu;
      e.preventDefault();
      this.handleMinutesChange(((((_this$props$time = this.props.time) === null || _this$props$time === void 0 ? void 0 : (_this$props$time$minu = _this$props$time.minutes) === null || _this$props$time$minu === void 0 ? void 0 : _this$props$time$minu.call(_this$props$time)) ?? 0) - 1).toString());
    };
    this.addMinuteClick = e => {
      var _this$props$time2, _this$props$time2$min;
      e.preventDefault();
      this.handleMinutesChange(((((_this$props$time2 = this.props.time) === null || _this$props$time2 === void 0 ? void 0 : (_this$props$time2$min = _this$props$time2.minutes) === null || _this$props$time2$min === void 0 ? void 0 : _this$props$time2$min.call(_this$props$time2)) ?? 0) + 1).toString());
    };
    this.removeHourClick = e => {
      var _this$props$time3, _this$props$time3$hou;
      e.preventDefault();
      this.handleHoursChange(((((_this$props$time3 = this.props.time) === null || _this$props$time3 === void 0 ? void 0 : (_this$props$time3$hou = _this$props$time3.hours) === null || _this$props$time3$hou === void 0 ? void 0 : _this$props$time3$hou.call(_this$props$time3)) ?? 0) - 1).toString());
    };
    this.onHoursChanged = e => {
      // this.handleHoursChange(e.target.value);
      this.setState({
        hoursText: e.target.value
      });
    };
    this.addHourClick = e => {
      var _this$props$time4, _this$props$time4$hou;
      e.preventDefault();
      this.handleHoursChange(((((_this$props$time4 = this.props.time) === null || _this$props$time4 === void 0 ? void 0 : (_this$props$time4$hou = _this$props$time4.hours) === null || _this$props$time4$hou === void 0 ? void 0 : _this$props$time4$hou.call(_this$props$time4)) ?? 0) + 1).toString());
    };
    this.handleHoursChange = this.handleHoursChange.bind(this);
    this.handleMinutesChange = this.handleMinutesChange.bind(this);
  }
  render() {
    var _this$props$time5, _this$props$time5$hou, _this$props$time6, _this$props$time6$min;
    let hours = ((_this$props$time5 = this.props.time) === null || _this$props$time5 === void 0 ? void 0 : (_this$props$time5$hou = _this$props$time5.hours) === null || _this$props$time5$hou === void 0 ? void 0 : _this$props$time5$hou.call(_this$props$time5)) ?? 0;
    let minutes = ((_this$props$time6 = this.props.time) === null || _this$props$time6 === void 0 ? void 0 : (_this$props$time6$min = _this$props$time6.minutes) === null || _this$props$time6$min === void 0 ? void 0 : _this$props$time6$min.call(_this$props$time6)) ?? 0;
    if (minutes < 0) {
      hours--;
    }
    minutes = (minutes + 60) % 60;
    hours = (hours + 24) % 24;
    var mid = 'AM';
    if (hours % 24 >= 12) {
      hours = hours % 12;
      mid = 'PM';
    }
    if (hours % 12 === 0) {
      // At 00 hours we need to show 12 am
      hours = 12;
    }
    if (this.props.showDateDiff && this.props.min) {
      const diffDays = _TimeUtil.default.dayDiff(this.props.min, this.props.time);
      if (diffDays > 0) {
        mid += ' +' + diffDays.toString();
      }
    }
    return /*#__PURE__*/React.createElement(_InputGroup.default, {
      title: this.props.title,
      tooltip: this.props.tooltip,
      className: this.props.inputGroupClassName
    }, /*#__PURE__*/React.createElement("div", _extends({}, this.props.id && {
      id: this.props.id
    }, {
      className: (0, _classnames.default)('input__base time-input', this.getValidationClass(), this.props.className),
      ref: this.containerRef
    }), /*#__PURE__*/React.createElement("div", {
      className: ""
    }, /*#__PURE__*/React.createElement("div", {
      className: "time-input__arrows__container"
    }, /*#__PURE__*/React.createElement("button", _extends({
      className: "plus",
      onClick: this.addHourClick
    }, this.props.id && {
      id: this.props.id + '-add-hours-button'
    }, {
      tabIndex: 0
    }), /*#__PURE__*/React.createElement(ArrowIcon, null)), /*#__PURE__*/React.createElement("div", {
      className: "input-padding"
    }, /*#__PURE__*/React.createElement("input", _extends({}, this.props.id && {
      id: this.props.id + '-hours-input'
    }, {
      disabled: this.getDisabled(),
      required: this.props.required,
      className: 'time-input__time ' + (this.state.value ? 'filled' : ''),
      onChange: this.onHoursChanged,
      value: this.state.hoursText !== undefined ? this.state.hoursText : hours,
      onBlur: this.onBlur,
      onFocus: this.handleFocus,
      type: "number"
    })), /*#__PURE__*/React.createElement("span", {
      className: "highlight"
    })), /*#__PURE__*/React.createElement("button", _extends({
      className: "minus",
      onClick: this.removeHourClick
    }, this.props.id && {
      id: this.props.id + '-subtract-hours-button'
    }, {
      tabIndex: 0
    }), /*#__PURE__*/React.createElement(ArrowIcon, null)))), /*#__PURE__*/React.createElement("span", {
      className: ""
    }, ":"), /*#__PURE__*/React.createElement("div", {
      className: ""
    }, /*#__PURE__*/React.createElement("div", {
      className: "time-input__arrows__container"
    }, /*#__PURE__*/React.createElement("button", _extends({
      className: "plus",
      onClick: this.addMinuteClick
    }, this.props.id && {
      id: this.props.id + '-add-minutes-button'
    }, {
      tabIndex: 0
    }), /*#__PURE__*/React.createElement(ArrowIcon, null)), /*#__PURE__*/React.createElement("div", {
      className: "input-padding"
    }, /*#__PURE__*/React.createElement("input", _extends({}, this.props.id && {
      id: this.props.id + '-minutes-input'
    }, {
      disabled: this.getDisabled(),
      required: this.props.required,
      className: 'time-input__time ' + (this.state.value ? 'filled' : ''),
      onChange: this.onMinutesChanged,
      value: this.state.minutesText !== undefined ? this.state.minutesText : minutes < 10 ? '0' + minutes.toString() : minutes.toString(),
      onBlur: this.onBlur,
      onFocus: this.handleFocus,
      type: "number"
    })), /*#__PURE__*/React.createElement("span", {
      className: "highlight"
    })), /*#__PURE__*/React.createElement("button", _extends({
      className: "minus",
      onClick: this.removeMinuteClick
    }, this.props.id && {
      id: this.props.id + '-subtract-minutes-button'
    }, {
      tabIndex: 0
    }), /*#__PURE__*/React.createElement(ArrowIcon, null)))), this.renderDefaultValidation(), /*#__PURE__*/React.createElement("span", {
      className: "time-input__am-pm"
    }, mid), /*#__PURE__*/React.createElement("span", {
      className: "highlight"
    }), /*#__PURE__*/React.createElement("span", {
      className: 'bar ' + (this.state.focused ? 'focused' : '')
    }), this.props.label && /*#__PURE__*/React.createElement("label", {
      className: (0, _classnames.default)('time-input__label label--focused')
    }, this.renderLabel())));
  }
  handleLimits(time) {
    if (this.props.min) {
      var _time$asMilliseconds;
      if (((time === null || time === void 0 ? void 0 : (_time$asMilliseconds = time.asMilliseconds) === null || _time$asMilliseconds === void 0 ? void 0 : _time$asMilliseconds.call(time)) ?? 0) - this.props.min.asMilliseconds() <= 0) {
        this.props.timeChange(this.props.min.clone());
        return;
      }
    }
    if (this.props.max) {
      var _time$asMilliseconds2;
      if (this.props.max.asMilliseconds() - ((time === null || time === void 0 ? void 0 : (_time$asMilliseconds2 = time.asMilliseconds) === null || _time$asMilliseconds2 === void 0 ? void 0 : _time$asMilliseconds2.call(time)) ?? 0) <= 0) {
        this.props.timeChange(this.props.max.clone());
        return;
      }
    }
    this.props.timeChange(time);
  }
  handleHoursChange(hoursString) {
    let num = Number(hoursString);
    if (hoursString === '') {
      num = 0;
    }
    if (!isNaN(num)) {
      var _this$props$time7, _this$props$time7$asM, _this$props$time8, _this$props$time8$hou;
      let newTime = _moment.default.duration(((_this$props$time7 = this.props.time) === null || _this$props$time7 === void 0 ? void 0 : (_this$props$time7$asM = _this$props$time7.asMilliseconds) === null || _this$props$time7$asM === void 0 ? void 0 : _this$props$time7$asM.call(_this$props$time7)) ?? 0, 'milliseconds').subtract(((_this$props$time8 = this.props.time) === null || _this$props$time8 === void 0 ? void 0 : (_this$props$time8$hou = _this$props$time8.hours) === null || _this$props$time8$hou === void 0 ? void 0 : _this$props$time8$hou.call(_this$props$time8)) ?? 0, 'hours').add(num, 'hours');
      this.handleLimits(newTime);
    }
  }
  handleMinutesChange(minutesString) {
    let num = Number(minutesString);
    if (minutesString === '') {
      num = 0;
    }
    if (!isNaN(num)) {
      var _this$props$time9, _this$props$time9$asM, _this$props$time10, _this$props$time10$mi;
      let newTime = _moment.default.duration(((_this$props$time9 = this.props.time) === null || _this$props$time9 === void 0 ? void 0 : (_this$props$time9$asM = _this$props$time9.asMilliseconds) === null || _this$props$time9$asM === void 0 ? void 0 : _this$props$time9$asM.call(_this$props$time9)) ?? 0, 'milliseconds').subtract(((_this$props$time10 = this.props.time) === null || _this$props$time10 === void 0 ? void 0 : (_this$props$time10$mi = _this$props$time10.minutes) === null || _this$props$time10$mi === void 0 ? void 0 : _this$props$time10$mi.call(_this$props$time10)) ?? 0, 'minutes').add(num, 'minutes');
      this.handleLimits(newTime);
    }
  }
}
exports.TimeRaw = TimeRaw;
TimeRaw.defaultProps = Object.assign({}, _BaseInput.BaseInput.defaultProps, {
  type: 'time',
  placeholder: ''
});
const Time = (0, _withThemeContext.withThemeContext)((0, _withFormContext.withFormContext)(TimeRaw), 'time');
exports.Time = Time;
var _default = Time;
exports.default = _default;
//# sourceMappingURL=Time.js.map