import * as React from 'react';
import { BaseInputProps, BaseInputState, BaseInput } from '../base/input/BaseInput';
import { Duration } from 'moment';
export declare enum TimeSpanUnit {
    Dynamic = 0,
    Millisecond = 1,
    Second = 2,
    Minute = 4,
    Hour = 8,
    Day = 16,
    Year = 32
}
export declare const allTimeSpanUnits: TimeSpanUnit;
export interface TimeSpanProps extends BaseInputProps<HTMLInputElement> {
    onChange?: never;
    timeSpanChange: (time: Duration) => void;
    timeSpan: Duration;
    min?: Duration;
    max?: Duration;
    initialUnits?: TimeSpanUnit;
    units?: TimeSpanUnit;
    validUnits?: TimeSpanUnit;
    unitToString?: (unit: TimeSpanUnit) => string;
}
export interface TimeSpanState extends BaseInputState {
    currentUnitText: string;
    currentUnit: TimeSpanUnit | undefined;
}
export declare class TimeSpanRaw extends BaseInput<TimeSpanProps, TimeSpanState, HTMLInputElement> {
    static defaultProps: TimeSpanProps;
    constructor(props: TimeSpanProps);
    render(): React.JSX.Element;
    private getUnits;
    private getValue;
    private oneUnitInMs;
    private maxOfUnit;
    private commitState;
    private onBlur;
    private removeUnitClick;
    private onUnitChanged;
    private onKeyDown;
    private addUnitClick;
    private handleLimits;
}
export declare const TimeSpan: React.ForwardRefExoticComponent<TimeSpanProps & React.RefAttributes<TimeSpanRaw>>;
export default TimeSpan;
