"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NumberValidator = void 0;
class NumberValidator {
  constructor() {
    let config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      min: undefined,
      max: undefined
    };
    this.config = void 0;
    this.config = config;
  }
  Validate(value, isRequired, addError) {
    let num = Number(value);
    if (!isNaN(num)) {
      if (this.config.min !== undefined && num <= this.config.min) {
        addError('Min: ' + this.config.min);
        return false;
      }
      if (this.config.max !== undefined && num >= this.config.max) {
        addError('Max: ' + (this.config.max - 1));
        return false;
      }
      if (this.config.minInclusive !== undefined && num < this.config.minInclusive) {
        addError('Min: ' + this.config.minInclusive);
        return false;
      }
      if (this.config.maxInclusive !== undefined && num >= this.config.maxInclusive) {
        addError('Max: ' + (this.config.maxInclusive - 1));
        return false;
      }
      return true;
    }
    addError('Invalid number');
    return false;
  }
}
exports.NumberValidator = NumberValidator;
//# sourceMappingURL=NumberValidator.js.map